<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of fileManagement
 *
 * @author migue
 */
class fileManagement {

    protected $bc;
    protected $ba;

    public function __construct() {
        include "./includes/variables.php";
        include "./misc/database.php";
        include '/usr/fallback/beroConf.php';
        $this->bc = new beroConf('root');
        $this->ba = new beroAri();
    }

    protected function generalValue($field) {
        $query = $this->ba->select("select " . $field . " from general");
        return sqlite_fetch_single($query);
    }

    protected function pstnValue($field, $group, $table) {
        $query = $this->ba->select('select ' . $field . ' from ' . $table . ' where gr=\'' . $group . '\' group by gr');
        return sqlite_fetch_single($query);
    }

    protected function getValue($config_option, $db_field, $default) {
        $ret = $config_option . '=';
        $ret.=($this->ba->get($db_field) != "") ? $this->ba->get($db_field) : $default;
        $ret.="\n";
        return $ret;
    }

    protected function addComma($var, $value, $force=false) {
        ($var == "" && $force==false) ? $var = $value : $var.="," . $value;
        return $var;
    }

    /**
     * @param integer id Line interface Nummer
     * @param integer lif1 Name des Li im lif1
     * @access protected
     * @return string
     */
    protected function lifX($id, $lif1) {
        $hw_cont = "[lif" . $id . "]\n";
        $type = sqlite_fetch_single($this->ba->select('SELECT type FROM isdn WHERE lif=\'' . $id . '\' and type!="bf2t1e1" and type!="bf1t1e1" and type!="bf4t1e1" union '
                            . 'SELECT type FROM analog WHERE lif=\'' . $id . '\' union '
                            . 'SELECT type FROM gsm WHERE lif=\'' . $id . '\' union '
                            . 'SELECT type FROM cas WHERE lif=\'' . $id . '\''));
        if ($type != "") {

            $hw_cont.="type=" . $type . "\n";


            $query = $this->ba->select('SELECT master, port, port_type FROM isdn WHERE lif=\'' . $id . '\' and type!="bf2t1e1" and type!="bf1t1e1" and type!="bf4t1e1" union '
                    . 'SELECT master, port, port_type FROM analog WHERE lif=\'' . $id . '\' union '
                    . 'SELECT master, port, port_type FROM gsm WHERE lif=\'' . $id . '\'  union '
                    . 'SELECT master, port, port_type FROM cas WHERE lif=\'' . $id . '\' order by port');
            while ($entry = $this->ba->fetch_array($query)) {
                $master = $entry['master'];
                //Bei analog oder gsm ports Durchlauf abbrechen
                if ($entry['port_type'] == "FXS" || $entry['port_type'] == "FXO" || $entry['port_type'] == "GSM")
                    continue;
                //T1E1 Modul
                elseif ($entry['port_type'] == "cas" || $entry['port_type'] == "hdlc") {
                    $q_cas = $this->ba->select('SELECT * FROM cas WHERE port=\'' . $entry['port'] . '\'');
                    while ($entry_cas = $this->ba->fetch_array($q_cas)) {
                        $protocol = $this->addComma($protocol, $entry_cas['protocol']);
                        $termination = $this->addComma($termination, $entry_cas['termination']);
                        $interface_type = $this->addComma($interface_type, $entry_cas['port_type']);
                        $country = $this->addComma($country, $entry_cas['country']);
                        $sigchan = $this->addComma($sigchan, $entry_cas['sigchan']);
                        //T1E1 clock for lif 0
                        if ($entry_cas['clock'] == "1" && $id == 0)
                            $clock = $entry_cas['port']-1;
                        //T1E1 clock for lif 1
                        elseif ($entry_cas['clock'] == "1" && $id == 1) {
                            $q = $this->ba->select('SELECT * FROM cas WHERE lif=0 order by port');
                            $clock = $entry_cas['port'] - sqlite_num_rows($q)-1;
                        }
                    }
                    //ISDN Module
                } else {
                    $q_isdn = $this->ba->select('SELECT * FROM isdn WHERE port=\'' . $entry['port'] . '\' and type!="bf2t1e1" and type!="bf1t1e1" and type!="bf4t1e1"');
                    while ($entry_isdn = $this->ba->fetch_array($q_isdn)) {
                        $ntteSW = $this->addComma($ntteSW, $entry_isdn['ntteSW']);
                        $ntteHW = $this->addComma($ntteHW, $entry_isdn['ntteHW']);
                        $crystal_clock = $this->addComma($crystal_clock, $entry_isdn['crystal_clock']);
                        $permanentl1 = $this->addComma($permanentl1, $entry_isdn['permanentl1']);
                        $termination = $this->addComma($termination, $entry_isdn['lt']);
                        $crc = $this->addComma($crc, $entry_isdn['crc']);
                        $ptp = $this->addComma($ptp, $entry_isdn['ptp']);
                        //ISDN clock for lif 0
                        if ($entry_isdn['clock'] == "1" && $id == 0)
                            $clock = $entry_isdn['port'];
                        //ISDN clock for lif 1
                        elseif ($entry_isdn['clock'] == "1" && $id == 1) {
                            $q = $this->ba->select('SELECT * FROM isdn WHERE lif=0 and type!="bf2t1e1" and type!="bf1t1e1" and type!="bf4t1e1" order by port');
                            $clock = $entry_isdn['port'] - sqlite_num_rows($q);
                        }
                    }
                }
            }
            $hw_cont.="master=" . $master . "\n";
            //ISDN Module
            if ($type == "bf1S0" || $type == "bf2S0" || $type == "bf4S0" || $type == "bf1E1" || $type == "bf2E1" || $type == "bf2S02FXS") {
                //Crystal clock BRI Ports
                if ($this->ba->get('sync_port_li' . $id) == 1)
                    $clock = 5;
                if ($this->ba->get('sync_port_auto' . $id) == 1)
                    $clock = 0;
                //Default Werte speichern wenn kein Clock
                if ($clock=="" && $master==0)
                    $clock=0;
                else if ($clock=="" && $master==1)
                    $clock=0;

                $hw_cont.="clock=" . $clock . "\n";
                $hw_cont.="ntteSW=" . $ntteSW . "\n";
                $hw_cont.="ntteHW=" . $ntteHW . "\n";
                $hw_cont.="permanentl1=" . $permanentl1 . "\n";
                //Portswitch Lif1
                if ($type == "bf4S0" && $id == 1) {
                    $hw_cont.="portswitch=0\n";
                }
                if ($type != "bf2E1" && $type != "bf1E1")
                    $hw_cont.="termination=" . $termination . "\n";
                if ($type == "bf2E1" || $type == "bf1E1")
                    $hw_cont.="crc=" . $crc . "\n";
                if ($type == "bf2E1" || $type == "bf1E1")
                    $hw_cont.="crystal_clock=" . $crystal_clock . "\n";
                $revision = exec('sed -ne "s/.*revision=\(.*\)/\1/p" /proc/cmdline');
                //Set portswitch for lif 0 if lif 1 is gsm
                if (($lif1 == "bf2GSM" || $lif1 == "bf1GSM") && $id == 0)
                    $hw_cont.="portswitch=1\n";
                //Portswitch option for HW revision 1.80 (just for lif0)
                if ($lif1 == "none" && $id == 0 && ($type == "bf4S0" || $type == "bf2S02FXS") && $revision != "1.80" && $revision != "1.8") {
                    $q = $this->ba->select('SELECT value FROM key_val WHERE key="portswitch"');
                    $v = sqlite_fetch_single($q);
                    $hw_cont.="portswitch=" . $v . "\n";
                } elseif (($type == "bf4S0" || $type == "bf2S02FXS") && $lif1 != "bf2GSM" && $lif1 != "bf1GSM" && $id = 0) {
                    $hw_cont.="portswitch=0\n";
                } elseif ($type == "bf2S0" || $type == "bf1S0" && $id == 0) {
                    $hw_cont.="portswitch=0\n";
                }

                if ($type == "bf2S02FXS") {
                    $hw_cont.="country=" . $this->ba->get('country') . "\n";
                    $hw_cont.=($this->ba->get('boostringer') == "") ? "boostringer=0\n" : "boostringer=" . $this->ba->get('boostringer') . "\n";
                }
                $hw_cont.="ptp=" . $ptp . "\n\n";
                //GSM Module
            } elseif ($type == "bf2GSM" || $type == "bf1GSM") {
                $query = $this->ba->select('SELECT pin,smsc FROM gsm WHERE lif=\'' . $id . '\' order by port');
                $j=0;
                while ($entry = $this->ba->fetch_array($query)) {
                    //Wenn das Feld PIN oder SMSC leer sind trotzdem en Komme bei dem zweiten hinzufügen
                    ($j==0) ? $pin = $this->addComma($pin, $entry['pin']) : $pin = $this->addComma($pin, $entry['pin'],true);
                    ($j==0) ? $smsc = $this->addComma($smsc, $entry['smsc']) : $smsc = $this->addComma($smsc, $entry['smsc'], true);
                    $j++;
                }
                $hw_cont.="pin=" . $pin . "\n";
                $hw_cont.="smsc=" . $smsc . "\n";
                //CAS Module
            } elseif ($type == "bf1t1e1" || $type == "bf2t1e1" || $type == "bf4t1e1") {
                //Crystal clock and auto Ports Li0
                if ($this->ba->get('sync_port_li' . $id) == 1)
                    $clock = 254;
                if ($this->ba->get('sync_port_auto' . $id) == 1)
                    $clock = 0;
                if ($clock===null)
                    $clock = 254;

                $hw_cont.="clock=$clock\n";
                $hw_cont.="interface_type=$interface_type\n";
                $hw_cont.="termination=$termination\n";
                $hw_cont.="protocol=$protocol\n";
                $hw_cont.="sigchan=$sigchan\n";
                $hw_cont.="country=$country\n";
                $hw_cont.="\n";
            } else {
                if ($lif1 == "none" && $id = 0 && $revision != "1.80" && $revision != "1.8") {
                    $q = $this->ba->select('SELECT value FROM key_val WHERE key="portswitch"');
                    $v = sqlite_fetch_single($q);
                    $hw_cont.="portswitch=" . $v . "\n";
                } elseif ($lif1 == "bf2GSM" || $lif1 == "bf1GSM" && $id == 0) {
                    $hw_cont.="portswitch=1\n";
                } else {
                    $hw_cont.="portswitch=0\n";
                }
                $hw_cont.="country=" . $this->ba->get('country') . "\n";
                $hw_cont.="ohs=" . $this->ba->get('ohs') . "\n";
                $hw_cont.="ohs2=" . $this->ba->get('ohs2') . "\n";
                $hw_cont.="rz=" . $this->ba->get('rz') . "\n";
                $hw_cont.="rt=" . $this->ba->get('rt') . "\n";
                $hw_cont.="rt2=" . $this->ba->get('rt2') . "\n";
                $hw_cont.="dcv=" . $this->ba->get('dcv') . "\n";
                $hw_cont.="mini=" . $this->ba->get('mini') . "\n";
                $hw_cont.="ilim=" . $this->ba->get('ilim') . "\n";
                $hw_cont.="acim=" . $this->ba->get('acim') . "\n";
                if ($type == "bf4FXS" || $type == "bf8FXS" || $type == "bf1FXS")
                    $hw_cont.= ($this->ba->get('boostringer') == "") ? "boostringer=0\n" : "boostringer=".$this->ba->get('boostringer') . "\n";
                $hw_cont.="\n";
            }
        }else {
            $hw_cont.="type=none\n";
            //Wenn PCM master=1 und kein lif1 gesteckt ist master=0
            if ($id = 1) {
                $query = $this->ba->select('SELECT master FROM isdn where type!="bf2t1e1" and type!="bf1t1e1" and type!="bf4t1e1" union SELECT master FROM analog union SELECT master FROM gsm union SELECT master FROM cas');
                $master = true;
                while ($entry = $this->ba->fetch_array($query)) {
                    if ($entry['master'] == '1')
                        $master = false;
                }
                if ($master)
                    $hw_cont.="master=0\n\n";
            }
            $hw_cont.="\n";
        }
        return $hw_cont;
    }

    protected function saveFile($filename, $content) {
        if (!file_exists($filename)) {
            $fp = fopen($filename, "w+");
            $write = fputs($fp, html_entity_decode($content));
            fclose($fp);
        } else if (file_exists($filename)) {
            $fp = fopen($filename, "w+");
            $write = fputs($fp, html_entity_decode($content));
            fclose($fp);
        }
    }

    public function isgwConf() {
        $isgw_cont = "[general]\n";

        $isgw_cont.="statusport=54322\n";
        $isgw_cont.="logserver=" . $this->generalValue('logserver') . "\n";
        $isgw_cont.="logging_active=" . $this->generalValue('logging_active') . "\n";
        $isgw_cont.="logging_message=" . $this->generalValue('logging_active') . "\n";
        $isgw_cont.="loglevel_message=" . $this->generalValue('loglevel') . "\n";

        $isgw_cont.=$this->getValue("syslog_facility", "syslog_facility", "16");
        $isgw_cont.=$this->getValue("reject_calls_under_load", "reject_calls_under_load", "0");
        $isgw_cont.=$this->getValue("pcm_server", "pcm_server", "0");
        $isgw_cont.=$this->getValue("pcm_server_port", "pcm_server_port", "54329");
        $isgw_cont.=$this->getValue("logcdr", "logcdr", "0");

        $isgw_cont.="msp_bridging=YES\n";
        $isgw_cont.="experimental_options=" . $this->ba->get("experimental_options") . "\n";

        if ($this->bc->get("root", "vlan-enable") == "1") {
            $isgw_cont.="interface_host=eth0." . $this->bc->get("root", "vlan-id") . "\n";
        }

        $this->saveFile("/usr/conf/isgw.conf", $isgw_cont);
    }

    public function isgwSip() {
        $sip_cont = "[general]\n";

        $query = $this->ba->select("select * from sip_general");
        while ($entry = $this->ba->fetch_array($query)) {
            $sip_cont.="sip_address=sip:0.0.0.0:" . $entry['bindport'] . "\n";
            $sip_cont.= ($entry['udpports'] != "") ? "udpports=" . $entry['udpports'] . "\n" : "";
        }

        $sip_cont.="sip_transport=" . $this->ba->get("sip_transport") . "\n";
        $sip_cont.="ssl_version=" . $this->ba->get("ssl_version") . "\n";
        $sip_cont.=($this->ba->get("tos_rtp") == "") ? "tos_rtp=160\n" : "tos_rtp=" . $this->ba->get("tos_rtp") . "\n";
        $sip_cont.=($this->ba->get("tos_sip") == "") ? "tos_sip=160\n" : "tos_sip=" . $this->ba->get("tos_sip") . "\n";
        $sip_cont.="rtp_port_selection=" . $this->ba->get("rtp_port_selection") . "\n";


        $query_sip = $this->ba->select("select * from sip");

        while ($entry = $this->ba->fetch_array($query_sip)) {
            $sip_cont.="[" . $entry['name'] . "]\n";
            $sip_cont.="address = " . $entry['server_address'] . "\n";
            $sip_cont.="register = " . $entry['register'] . "\n";
            $sip_cont.="user = " . $entry['user'] . "\n";
            $sip_cont.="auth_user = " . $entry['auth_user'] . "\n";
            $sip_cont.="displayname = " . $entry['displayname'] . "\n";
            $sip_cont.="transport = " . $entry['sip_transport'] . "\n";
            $sip_cont.="secret = " . $entry['secret'] . "\n";
            if ($entry['register'] == '1'){
                $sip_cont.="regrefresh = " . $entry['regrefresh'] . "\n";
                $sip_cont.="register_options = " . $entry['register_option'] . "\n";
            }
            $sip_cont.="externip = " . $entry['externip'] . "\n";
            $sip_cont.="stunserver = " . $entry['stunserver'] . "\n";
            $sip_cont.="config = " . $entry['config'] . "\n";
            $sip_cont.="profile = " . $entry['profile'] . "\n";
            $sip_cont.="matchtype = " . $entry['matchtype'] . "\n";
            $sip_cont.="matchtype_manual = " . $entry['matchtype_manual'] . "\n";
            $sip_cont.="enum_support = " . $entry['enum_support'] . "\n";
            $sip_cont.="enum_search_domains = " . $entry['enum_search_domain'] . "\n";
        }

        $this->saveFile("/usr/conf/isgw.sip", $sip_cont);
    }

    public function isgwIsdn() {
        $file_isdn = "/usr/conf/isgw.isdn";
        $isdn_cont.="[general]\n";
        $isdn_cont.="time_from_isdn=" . $this->bc->get("root", "time_from_isdn") . "\n\n";
        $query = $this->ba->select('SELECT DISTINCT gr FROM isdn WHERE gr!="NULL"');
        while ($entry = $this->ba->fetch_array($query)) {
            $query_port = $this->ba->select('SELECT port FROM isdn WHERE gr=\'' . $entry['gr'] . '\' ORDER BY port asc');
            $ports = "";
            while ($entryp = $this->ba->fetch_array($query_port)) {
                $ports = $this->addComma($ports, $entryp['port']);
            }
            $group = $entry['gr'];
            $isdn_cont.="[" . $group . "]\n";
            $isdn_cont.="ports = " . $ports . "\n";
            $isdn_cont.="config = " . $this->pstnValue('config', $group, 'isdn') . "\n";
            $isdn_cont.="chansel = " . $this->pstnValue("chansel", $group, 'isdn') . "\n";
            $isdn_cont.="chansel_direction = " . $this->pstnValue("chansel_dir", $group, 'isdn') . "\n";
            $isdn_cont.="tones = " . $this->pstnValue("tones", $group, 'isdn') . "\n";
            $isdn_cont.="interdigit_timeout = " . $this->pstnValue("odt", $group, 'isdn') . "\n";
            $isdn_cont.="interdigit_timeout_initial = " . $this->pstnValue("odt_empty_dad", $group, 'isdn') . "\n";
            $isdn_cont.="overlap_dialing = " . $this->pstnValue("overlap_dialing", $group, 'isdn') . "\n";
            $isdn_cont.="qsig = " . $this->pstnValue("qsig", $group, 'isdn') . "\n";
            $isdn_cont.="portpullup = " . $this->pstnValue("portpullup", $group, 'isdn') . "\n";
            $isdn_cont.="pcmlaw = " . $this->pstnValue('pcmlaw', $group, 'isdn') . "\n";
            $isdn_cont.="country_code = " . $this->pstnValue('country_code', $group, 'isdn') . "\n";
            $isdn_cont.="city_code = " . $this->pstnValue('city_code', $group, 'isdn') . "\n";
            $isdn_cont.="local_area_code = " . $this->pstnValue('local_area_code', $group, 'isdn') . "\n";
        }

        $this->saveFile("/usr/conf/isgw.isdn", $isdn_cont);
    }

    public function hardwareConf() {
        //hardware.conf
        $query = $this->ba->select('SELECT type  FROM isdn WHERE lif="1" and type!="bf2t1e1" and type!="bf1t1e1" and type!="bf4t1e1" union '
                . 'SELECT type  FROM analog WHERE lif="1" union '
                . 'SELECT type  FROM gsm WHERE lif="1" union '
                . 'SELECT type FROM cas WHERE lif="1"');
        $tmp = sqlite_fetch_single($query);
        $lif1 = ($tmp == "") ? $lif1 = "none" : $lif1 = $tmp;



        $hw_cont = $this->lifX(0, $lif1);
        $hw_cont .= $this->lifX(1, $lif1);

        $hw_cont.="[pcm]\ntype=pcm\n";
        $query = $this->ba->select('SELECT master FROM isdn where type!="bf2t1e1" and type!="bf1t1e1" and type!="bf4t1e1" union SELECT master FROM analog union SELECT master FROM gsm union SELECT master FROM cas ');
        $master = true;
        while ($entry = $this->ba->fetch_array($query)) {
            if ($entry['master'] == '1')
                $master = false;
        }
        if (sqlite_num_rows($query)==0) $master=false;
        if ($master)
            $hw_cont.="master=1\n";
        else
            $hw_cont.="master=0\n";

        $this->saveFile("/usr/conf/hardware.conf", $hw_cont);
    }

    public function isgwCpt() {
        $cpt_cont = "";
        $query = $this->ba->select('SELECT * FROM callprogress');
        while ($entry = $this->ba->fetch_array($query)) {
            switch ($entry['direction']) {
                case "SIP-ISDN":
                    $direction = "s2i";
                    break;
                case "ISDN-SIP":
                    $direction = "i2s";
                    break;
                case "SIP-FXO":
                    $direction = "s2fxo";
                    break;
            }
            $cpt_cont.="[" . $direction . ":" . $entry['name'] . "]\n";
            if ($entry['direction'] == "SIP-FXO") {
                $cpt_cont.="TIMER_DIAL=" . $entry['timer_dial'] . "\n";
                $cpt_cont.="TIMER_POLREV=" . $entry['timer_polrev'] . "\n";
                $cpt_cont.="TIMER_ALERTING_STOP=" . $entry['timer_alerting_stop'] . "\n";
            }
            $q_ent = $this->ba->select('SELECT * FROM callprogress_entries WHERE id_name=\'' . $entry['id'] . '\'');
            while ($entry_ = $this->ba->fetch_array($q_ent)) {
                switch ($entry['direction']) {
                    case "SIP-ISDN":
                        $cpt_cont.=$entry_['type'] . "\t" . $entry_['chann_det'] . "\t" . $entry_['isdn_event'] . "\t" . $entry_['sip_resp'] . "\t" . $entry_['resp_text'] . "\n";
                        break;
                    case "ISDN-SIP":
                        $cpt_cont.=$entry_['type'] . "\t" . $entry_['isdn_event'] . "\t" . $entry_['resp_text'] . "\t" . $entry_['sip_resp'] . "\n";
                        break;
                    case "SIP-FXO":
                        $cpt_cont.=$entry_['isdn_event'] . "\t" . $entry_['sip_resp'] . "\t" . $entry_['resp_text'] . "\n";
                        break;
                }
            }
        }

        $this->saveFile("/usr/conf/isgw.cpt", $cpt_cont);
    }

    public function isgwAnalog() {
        //isgw.analog
        $analog_cont = "[general]\n";
        $query = $this->ba->select('SELECT DISTINCT gr FROM analog WHERE gr!="NULL"');
        while ($entry = $this->ba->fetch_array($query)) {
            $query_port = $this->ba->select('SELECT port FROM analog WHERE gr=\'' . $entry['gr'] . '\' ORDER BY port asc');
            $ports = "";
            while ($entryp = $this->ba->fetch_array($query_port)) {
                $ports = $this->addComma($ports, $entryp['port']);
            }

            $group = $entry['gr'];
            $port_type = $this->pstnValue('port_type', $group, 'analog');
            $analog_cont.="[" . $entry['gr'] . "]\n";
            $analog_cont.="ports = " . $ports . "\n";
            $analog_cont.="interdigit_timeout = " . $this->pstnValue('overlap_dial_timeout', $group, 'analog') . "\n";
            $analog_cont.="interdigit_timeout_initial = " . $this->pstnValue('overlap_dial_timeout_empty_dad', $group, 'analog') . "\n";
            $analog_cont.="overlap_dialing = " . $this->pstnValue('overlap_dialing', $group, 'analog') . "\n";
            $analog_cont.="tones = " . $this->pstnValue('tones', $group, 'analog') . "\n";
            $analog_cont.="clip = " . $this->pstnValue('clip', $group, 'analog') . "\n";
            $analog_cont.="cnip = " . $this->pstnValue('cnip', $group, 'analog') . "\n";
            $analog_cont.="chansel = " . $this->pstnValue('chansel', $group, 'analog') . "\n";
            $analog_cont.="chansel_direction = " . $this->pstnValue('chansel_dir', $group, 'analog') . "\n";
            if ($port_type == "FXO") {
                $analog_cont.="fxo_connect = " . $this->pstnValue('fxo_connect', $group, 'analog') . "\n";
                $analog_cont.="fxo_wait_for_oad = " . $this->pstnValue('fxo_wait_for_oad', $group, 'analog') . "\n";
                $analog_cont.="fxo_dialtone_passthrough = " . $this->pstnValue('fxo_dialtone_passthrough', $group, 'analog') . "\n";
                $analog_cont.="fxo_call_ending_signal = " . $this->pstnValue('fxo_call_ending_signal', $group, 'analog') . "\n";
                $analog_cont.="fxo_cid_detection_mode = " . $this->pstnValue('fxo_cid_detection_mode', $group, 'analog') . "\n";
            }
            if ($port_type == "FXS") {
                $analog_cont.="message_waiting_method = " . $this->pstnValue('message_waiting_method', $group, 'analog') . "\n";
            }
            $analog_cont.="config = " . $this->pstnValue('config', $group, 'analog') . "\n";
        }
        $this->saveFile("/usr/conf/isgw.analog", $analog_cont);
    }

    public function isgwCas() {
        //isgw.cas
        $cas_cont = "[general]\n";
        $query = $this->ba->select('SELECT DISTINCT gr FROM cas_channels WHERE gr!="NULL"');
        while ($entry = $this->ba->fetch_array($query)) {

            $query_channel = $this->ba->select('SELECT channel FROM cas_channels WHERE gr=\'' . $entry['gr'] . '\' ORDER BY channel asc');
            $channels = "";
            while ($entrych = $this->ba->fetch_array($query_channel)) {
                $channels = $this->addComma($channels, $entrych['channel']);
            }
            $group = $entry['gr'];
            $cas_cont.="[" . $entry['gr'] . "]\n";
            $cas_cont.="ports = " . $channels . "\n";
            $cas_cont.="t1_signalling = " . $this->pstnValue('t1sigtype', $group, 'cas_channels') . "\n";
            $cas_cont.="e1_signalling = " . $this->pstnValue('e1sigtype', $group, 'cas_channels') . "\n";
            $cas_cont.="interdigit_timeout = " . $this->pstnValue('interdigit_timeout', $group, 'cas_channels') . "\n";
            $cas_cont.="interdigit_timeout_initial = " . $this->pstnValue('interdigit_timeout_initial', $group, 'cas_channels') . "\n";
            $cas_cont.="overlap_dialing = " . $this->pstnValue('overlap_dialing', $group, 'cas_channels') . "\n";
            $cas_cont.="tones = " . $this->pstnValue('tones', $group, 'cas_channels') . "\n";
            $cas_cont.="clip = " . $this->pstnValue('clip', $group, 'cas_channels') . "\n";
            $cas_cont.="cnip = " . $this->pstnValue('cnip', $group, 'cas_channels') . "\n";
            $cas_cont.="chansel = " . $this->pstnValue('chansel', $group, 'cas_channels') . "\n";
            $cas_cont.="chansel_direction = " . $this->pstnValue('chansel_dir', $group, 'cas_channels') . "\n";
            $cas_cont.="dialtone_digits = " . $this->pstnValue('dialtone_digits', $group, 'cas_channels') . "\n";
            $cas_cont.="wait_for_oad = " . $this->pstnValue('wait_for_oad', $group, 'cas_channels') . "\n";
            $cas_cont.="pcmlaw = " . $this->pstnValue('pcmlaw', $group, 'cas_channels') . "\n";
            $cas_cont.="fxo_wait_for_oad = " . $this->pstnValue('fxo_wait_for_oad', $group, 'cas_channels') . "\n";
            $cas_cont.="fxo_callerid_detection_timeout = " . $this->pstnValue('fxo_callerid_detection_timeout', $group, 'cas_channels') . "\n";
            $cas_cont.="fxo_call_ending_signal = " . $this->pstnValue('fxo_call_ending_signal', $group, 'cas_channels') . "\n";
            $cas_cont.="fxo_cid_detection_mode = " . $this->pstnValue('fxo_cid_detection_mode', $group, 'cas_channels') . "\n";
            $cas_cont.="config = " . $this->pstnValue('config', $group, 'cas_channels') . "\n";
        }

        $this->saveFile("/usr/conf/isgw.cas", $cas_cont);
    }

    public function isgwGsm() {
        $gsm_cont = "[general]\n";
        $query = $this->ba->select('SELECT * FROM gsm ORDER BY port ASC');
        $j=0;
        while ($entry_gsm = $this->ba->fetch_array($query)) {
            //Wenn das Feld PIN oder SMSC leer sind trotzdem en Komme bei dem zweiten hinzufügen
            ($j==0) ? $pin = $this->addComma($pin, $entry_gsm['pin']) : $pin = $this->addComma($pin, $entry_gsm['pin'],true);
            ($j==0) ? $smsc = $this->addComma($smsc, $entry_gsm['smsc']) : $smsc = $this->addComma($smsc, $entry_gsm['smsc'],true);
            $j++;
        }
        $gsm_cont.="pin=" . $pin . "\n";
        $gsm_cont.="smsc=" . $smsc . "\n";
        $query = $this->ba->select('SELECT DISTINCT gr FROM gsm WHERE gr!="NULL"');
        while ($entry = $this->ba->fetch_array($query)) {

            $query_port = $this->ba->select('SELECT port FROM gsm WHERE gr=\'' . $entry['gr'] . '\' ORDER BY port asc');
            $ports = "";
            while ($entryp = $this->ba->fetch_array($query_port)) {
                $ports = $this->addComma($ports, $entryp['port']);
            }


            $gsm_cont.="[" . $entry['gr'] . "]\n";
            $gsm_cont.="ports = " . $ports . "\n";
            $gsm_cont.="config = " . $this->pstnValue('config', $group, 'gsm') . "\n";
            $gsm_cont.="sms_extensions = " . $this->pstnValue('sms_extension', $group, 'gsm') . "\n";
            $gsm_cont.="extensions = " . $this->pstnValue('extension', $group, 'gsm') . "\n";
            $gsm_cont.="chansel = " . $this->pstnValue('chansel', $group, 'gsm') . "\n";
            $gsm_cont.="chansel_direction = " . $this->pstnValue('chansel_dir', $group, 'gsm') . "\n";
            //$gsm_cont.="pin = ".$pin."\n";
            //$gsm_cont.="smsc = ".$smsc."\n";
        }

        $this->saveFile("/usr/conf/isgw.gsm", $gsm_cont);
    }

    public function miscConf() {
        //misc.conf
        $file_misc = "/usr/conf/misc.conf";
        $m_cont = "";
        $m_cont.="[general]\n";
        $m_cont.="ntphost=" . $this->bc->get("root", "ntphost") . "\n";
        $m_cont.="timezone=" . $this->bc->get("root", "timezone") . "\n";
        $m_cont.="root-version=" . $this->bc->get("root", "root-version") . "\n";
        $m_cont.="lan-iface=" . $this->bc->get("root", "lan-iface") . "\n";
        $m_cont.="lan-ipaddr=" . $this->bc->get("root", "lan-ipaddr") . "\n";
        $m_cont.="lan-netmask=" . $this->bc->get("root", "lan-netmask") . "\n";
        $m_cont.="lan-gateway=" . $this->bc->get("root", "lan-gateway") . "\n";
        $m_cont.="lan-nameserver=" . $this->bc->get("root", "lan-nameserver") . "\n";
        $m_cont.="lan-dhcp=" . $this->bc->get("root", "lan-dhcp") . "\n";
        $m_cont.="hostname=" . $this->ba->get('hostname') . "\n";
        $m_cont.="msp-iface=" . $this->bc->get("root", "msp-iface") . "\n";
        $m_cont.="msp-ipaddr=" . $this->bc->get("root", "msp-ipaddr") . "\n";
        $m_cont.="app-image=" . $this->bc->get("root", "app-image") . "\n";
        $m_cont.="app-status=" . $this->bc->get("root", "app-status") . "\n";
        $m_cont.="lan-mtu=" . $this->bc->get("root", "lan-mtu") . "\n";
        $m_cont.="use-boot-prov=" . $this->bc->get("root", "use-boot-prov") . "\n";
        $m_cont.="tftp-host=" . $this->bc->get("root", "tftp-host") . "\n";
        $m_cont.="tftp-url=" . $this->bc->get("root", "tftp-url") . "\n";
        $m_cont.="provisioning-option=" . $this->bc->get("root", "provisioning-option") . "\n";
        $m_cont.="vlan-enable=" . $this->bc->get("root", "vlan-enable") . "\n";
        $m_cont.="vlan-id=" . $this->bc->get("root", "vlan-id") . "\n";
        $m_cont.="routing=" . $this->bc->get("root", "routing") . "\n";
        $m_cont.="routing=" . $this->bc->get("root", "routing") . "\n";
        $m_cont.="cifs_log_enabled=" . $this->bc->get("root", "cifs_log_enabled") . "\n";
        $m_cont.="cifs_log_share=" . stripslashes($this->bc->get("root", "cifs_log_share")) . "\n";
        $m_cont.="cifs_log_user=" . $this->bc->get("root", "cifs_log_user") . "\n";
        $m_cont.="cifs_log_password=" . $this->bc->get("root", "cifs_log_password") . "\n";
        $m_cont.="cifs_log_domain=" . $this->bc->get("root", "cifs_log_domain") . "\n";

        $m_cont.="snmp-enabled=" . $this->bc->get("root", "snmp-enabled") . "\n";
        $m_cont.="snmptraps=" . $this->bc->get("root", "snmptraps") . "\n";
        $m_cont.="snmptraps_sink=" . $this->bc->get("root", "snmptraps_sink") . "\n";
        $m_cont.="snmptraps_intervall=" . $this->bc->get("root", "snmptraps_intervall") . "\n";
        $m_cont.="snmp-community-ro=" . $this->bc->get("root", "snmp-community-ro") . "\n";
        $m_cont.="snmp-community-rw=" . $this->bc->get("root", "snmp-community-rw") . "\n";
        $m_cont.="snmp-community-trap=" . $this->bc->get("root", "snmp-community-trap") . "\n";

        $m_cont.="httpsOnly=" . $this->ba->get("httpsOnly") . "\n";

        $m_cont.="cloud_enable=" . $this->bc->get("root", "cloud_enable") . "\n";
        $m_cont.="cloud_key=" . $this->bc->get("root", "cloud_key") . "\n";
        $m_cont.="vlan-prio=" . $this->bc->get("root", "vlan-prio") . "\n";
        $m_cont.="userapp-enabled=" . $this->bc->get("root", "userapp-enabled") . "\n";
        $m_cont.="userapp-user-enabled=" . $this->bc->get("root", "userapp-enabled") . "\n";
        $m_cont.="beroAvahi-enabled=" . $this->bc->get("root", "beroAvahi-enabled") . "\n";
        $m_cont.="system-check-enabled=" . $this->bc->get("root", "system-check-enabled") . "\n";
        $m_cont.="safeguard=" . $this->bc->get("root", "safeguard") . "\n";
        $m_cont.="cloudAddress=" . $this->ba->get('cloudAddress') . "\n";

        $m_cont.="proxyEnabled=" . $this->ba->get('proxyEnabled') . "\n";
        $m_cont.="proxyAddress=" . $this->ba->get('proxyAddress') . "\n";
        $m_cont.="proxyPort=" . $this->ba->get('proxyPort') . "\n";
        $m_cont.="proxyType=" . $this->ba->get('proxyType') . "\n";
        $m_cont.="proxyUser=" . $this->ba->get('proxyUser') . "\n";
        $m_cont.="proxySecret=" . $this->ba->get('proxySecret') . "\n";

        $m_cont.="summer_winter_time=" . $this->ba->get("summer_winter_time") . "\n";
        $m_cont.="set_hw=" . $this->ba->get("set_hw") . "\n";
        $m_cont.="bnfos-ipaddr=" . $this->ba->get("ip_berofos") . "\n";
        $m_cont.="bnfos-mac=" . $this->ba->get("mac_berofos") . "\n";
        $m_cont.="bnfos-intv=" . $this->ba->get("interval_berofos") . "\n";
        $m_cont.="bnfos-hb-on-boot=" . $this->bc->get("root", "use_boot_bnfoswdog") . "\n";
        $query = $this->ba->select('SELECT * FROM users where user!="beroAdmin"');
        while ($entry = $this->ba->fetch_array($query)) {
            $admin_user = $entry['user'];
            $admin_pass = $entry['password'];
        }
        $query = $this->ba->select('SELECT show_app FROM set_app');
        while ($entry = $this->ba->fetch_array($query))
            $sessions_disable = $entry['show_app'];
        $m_cont.="admin-pass=" . $admin_pass . "\n";
        $m_cont.="admin-user=" . $admin_user . "\n";
        $m_cont.="sessions-disable=" . $sessions_disable . "\n";
        
        $m_cont.="excludelan=" . $this->bc->get("root", "excludelan") . "\n";

        $this->saveFile("/usr/conf/misc.conf", $m_cont);
    }

    public function hostname() {
        //hostname
        $file_hostname = "/usr/conf/hostname";
        if ($this->ba->get('hostname') == "") {
            @unlink($file_hostname);
        } else {
            $hostname_cont = $this->ba->get('hostname');
            $this->saveFile($file_hostname, $hostname_cont);
        }
    }

    public function isgwCauses() {
        $c_cont = ";FROM\tTO\tINCAUSE\tOUTCAUSE\tOUTTEXT\n";
        $query_d = $this->ba->select("select * from isgw_causes");
        while ($entry = $this->ba->fetch_array($query_d)) {
            $dir = explode("-", $entry['direction']);
            $c_cont.=$dir[0] . "\t" . $dir[1] . "\t";
            $c_cont.=$entry['to_cause'] . "\t" . $entry['from_cause'] . "\t";
            $c_cont.=$entry['sip_response_message'] . "\t\n";
        }
        $this->saveFile("/usr/conf/isgw.causes", $c_cont);
    }
    
    
    public function networkAcl() {
        $query_bindport = $this->ba->select("select bindport from sip_general");
        $bindport = sqlite_fetch_single($query_bindport);
            
        $query = $this->ba->select("select * from acl");
        while ($entry = $this->ba->fetch_array($query)) {
            //SIP Port ist der Bindport, in der DB werden SIP regeln mit dem dest_port -1 gespeichert und hier durch den richtigen Port ersetzt
            if ($entry['dest_port']==-1) 
                $dest_port=$bindport ;
            //SIP-TSL Port ist der Bindport+1, in der DB werden SIP regeln mit dem dest_port -2 gespeichert und hier durch den richtigen Port ersetzt
            elseif ($entry['dest_port']==-2)  
                $dest_port=$bindport+1 ;
            else 
                $dest_port=$entry['dest_port'];
            
            $content.="INPUT;" . $entry['protocol'] . ";" . $dest_port . ";"
                    . $entry['address'] . "/" . $entry['netmask'] . ";ACCEPT\n";
        }
        $this->saveFile("/usr/conf/network.acl", $content);
    }

    public function isgwDialplan() {
        $d_cont = ";From\tTo\tFromID\tToID\tDestination\tNewDestination\tSource\tNewSource\tConfig\n";
        $query_d = $this->ba->select("select * from dialplan order by posId, id asc");
        while ($entry = $this->ba->fetch_array($query_d)) {
            if (($entry['fromDirection'] == 'isdn' || $entry['fromDirection'] == 'analog' || $entry['fromDirection'] == 'gsm' || $entry['fromDirection'] == 'cas') && ($entry['toDirection'] == 'isdn' || $entry['toDirection'] == 'analog' || $entry['toDirection'] == 'gsm' || $entry['toDirection'] == 'cas')) {
                ($entry['activ'] == "1") ? $d_cont.=$entry['fromDirection'] . "\t" : $d_cont.=";#" . $entry['fromDirection'] . "\t";
                //$d_cont.="isdn\t";
                $d_cont.="sip\t";
                $d_cont.=$entry['fromId'] . "\t";
                $d_cont.="127.0.0.1\t";
                $d_cont.=$entry['dest'] . "\t";
                if (strpos($entry['newDest'], "ISDNZUISDN") === false) {
                    $d_cont.=$entry['isdnid'] . $entry['newDest'] . "\t";
                } else {
                    $d_cont.=$entry['newDest'] . "\t";
                }
                $d_cont.=$entry['src'] . "\t";
                $d_cont.=$entry['newSrc'] . "\t";
                $d_cont.=$entry['config'] . "\n";

                $d_cont.=($entry['activ'] == "1") ? "sip\t" : ";#sip\t";
                $d_cont.=$entry['toDirection'] . "\t";
                $d_cont.="127.0.0.1\t";
                $d_cont.=$entry['toId'] . "\t";
                $d_cont.=$entry['isdnid'] . "(.*)" . "\t";
                $d_cont.=stripslashes("\\\\1") . "\t";
                $d_cont.=stripslashes("(.*)") . "\t";
                $d_cont.=stripslashes("\\\\1") . "\t";
                $d_cont.=$entry['config'] . "\n";
            } else {

                ($entry['activ'] == "1") ? $d_cont.=$entry['fromDirection'] . "\t" : $d_cont.=";#" . $entry['fromDirection'] . "\t";
                $d_cont.=$entry['toDirection'] . "\t";
                $d_cont.=$entry['fromId'] . "\t";
                $d_cont.=$entry['toId'] . "\t";
                $d_cont.=$entry['dest'] . "\t";
                $d_cont.=$entry['newDest'] . "\t";
                $d_cont.=$entry['src'] . "\t";
                $d_cont.=$entry['newSrc'] . "\t";
                $d_cont.=$entry['config'] . "\n";
            }
        }
        $this->saveFile("/usr/conf/isgw.dialplan", $d_cont);
    }
}
