<?php

$DEBUG = 0;

function error($str, $line) {
    echo "FAILURE:" . $str . " in line:" . $line . "\n";
    exit(-$line);
}

include_once("/usr/local/www/berogui/misc/database.php");

function ini_to_db($value = 0) {
    global $DEBUG;
    $strpath = "/usr/conf/";
    //$strpath="";
    $db = new beroAri($strpath . "ari.db");
    //1.0 & 2.0
    if ($DEBUG)
        echo "Parsing isgw.conf\n";
    $result = isgwconf_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    if ($DEBUG)
        echo "Parsing hardware.conf\n";
    $result = isdncfg_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    if ($DEBUG)
        echo "Parsing isgw.isdn\n";
    $result = isgwisdn_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    if ($DEBUG)
        echo "Parsing isgw.dialplan\n";
    $result = isgwdialplan_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    if ($DEBUG)
        echo "Parsing isgw.sip\n";
    $result = isgwsip_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    //late 1.0 and 2.0
    if ($DEBUG)
        echo "Parsing misc.conf\n";
    $result = misc_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    if ($DEBUG)
        echo "Parsing isgw.causes\n";
    $result = isgwcauses_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    //2.0 only
    if ($DEBUG)
        echo "Parsing isgw.analog\n";
    $result = isgwanalog_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    //3.0 only
    if ($DEBUG)
        echo "Parsing isgw.cas\n";
    $result = isgwcas_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    if ($DEBUG)
        echo "Parsing isgw.cpt\n";
    $result = isgwcpt_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    if ($DEBUG)
        echo "Parsing network.acl\n";
    $result = networkacl_initoDB($db, $strpath, $value);
    if (!$result)
        return false;
    //2.2 only
    if ($DEBUG)
        echo "Parsing isgw.gsm\n";
    $result = isgwgsm_initoDB($db, $strpath, $value);
    if (!$result)
        return false;

    return true;
}

function make_parseable_inifile($sFile, $dFile) {

    $handle = @fopen($sFile, "r"); // Open file form read.
    $whandle = fopen($dFile, "w");
    if ($handle) {
        $i = 0;
        while (!feof($handle)) { // Loop til end of file.
            $buffer = fgets($handle, 4096); // Read a line.
                $eqpos = strpos($buffer, "=");
                //Alle Zeilen maskieren da manche Zeilen in dem Value ein = Zeichen enthalten
                if ($eqpos!==false){
                    $key=trim(substr($buffer, 0 ,$eqpos));
                    $value = trim(substr($buffer, $eqpos + 1));
                    $buffer = $key."=\"" . $value . "\"\n";
                }
                //echo $buffer ."\n";

            if (strpos($key, "tones") !== false) {
                $buffer = str_replace("[", "", $buffer);
                $buffer = str_replace("]", "", $buffer);
                //echo $buffer . "\n";
            }
            if (strpos($key, "overlap_dialing") !== false) {
                $buffer = str_replace("yes", "1", $buffer);
                $buffer = str_replace("no", "0", $buffer);
                //echo $buffer . "\n";
            }
            if (strpos($key, "sip_over_tcp") !== false) {
                $buffer = str_replace("yes", "1", $buffer);
                $buffer = str_replace("no", "0", $buffer);
                //echo $buffer . "\n";
            }
            if (strpos($key, "time_from_isdn") !== false) {
                $buffer = str_replace("yes", "1", $buffer);
                $buffer = str_replace("no", "0", $buffer);
                //echo $buffer . "\n";
            }
             if (strpos($key, "qsig") !== false) {
                $buffer = str_replace("yes", "1", $buffer);
                $buffer = str_replace("no", "0", $buffer);
                //echo $buffer . "\n";
            }
            if (strpos($buffer, "lan-dhcp") !== false) {
                $buffer = str_replace("yes", "1", $buffer);
                $buffer = str_replace("no", "0", $buffer);
                //echo $buffer . "\n";
            }
            if (strpos($key, "use-boot-prov") !== false) {
                $buffer = str_replace("yes", "1", $buffer);
                $buffer = str_replace("no", "0", $buffer);
                //echo $buffer . "\n";
            }
            if (strpos($key, "bnfos-hb-on-boot") !== false) {
                $buffer = str_replace("yes", "1", $buffer);
                $buffer = str_replace("no", "0", $buffer);
                //echo $buffer . "\n";
            }

            $wbuffer = fwrite($whandle, $buffer);
            $i++;
            //echo $i . ":"  .$buffer . "\n";
        }
        fclose($handle); // Close the file.
    }
    return;
}

function isgwconf_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;

    if (!file_exists($strpath . "isgw.conf"))
        error("no isgw.conf found", __LINE__);

    $result = make_parseable_inifile($strpath . "isgw.conf", $strpath . "isgw.conf.tmp");

    $result = parse_ini_file($strpath . "isgw.conf.tmp", true);

    foreach ($result as $section => $values) {

        if ($section == "general") {


            $statusport = $result[$section][statusport];
            $logserver = $result[$section][logserver];
            $logging_active = $result[$section][logging_active];
            $loglevel = $result[$section][loglevel];


            $syslog_facility = $result[$section][syslog_facility];
            if ($syslog_facility == "")
                $syslog_facility = "16";

            $db->set('syslog_facility', sqlite_escape_string ($syslog_facility));

            $experimental_options = $result[$section][experimental_options];
            $db->set('experimental_options', sqlite_escape_string ($experimental_options));

            //pcm_server
            $pcm_server = $result[$section][pcm_server];
            if ($pcm_server == "")
                $pcm_server = "0";
            $db->set('pcm_server', sqlite_escape_string ($pcm_server));

            $pcm_server_port = $result[$section][pcm_server_port];
            if ($pcm_server_port == "")
                $pcm_server_port = "54329";
            $db->set('pcm_server_port', sqlite_escape_string ($pcm_server_port));

            //logcdr
            $logcdr = $result[$section][logcdr];
            if ($logcdr == "")
                $logcdr = "0";
            $db->set('logcdr', sqlite_escape_string ($logcdr));


            //reject_calls_under_load
            $reject_calls_under_load = $result[$section][reject_calls_under_load];
            if ($reject_calls_under_load == "")
                $reject_calls_under_load = 0;
            $db->set("reject_calls_under_load", sqlite_escape_string ($reject_calls_under_load));
            if ($DEBUG)
                echo "isgwconf->DB: Key_val:reject_calls_under_load=" . sqlite_escape_string ($reject_calls_under_load) . " \n";

            //$msp_bridging=$result[$section][msp_bridging];


            $strsql = "Insert into general ('id','logserver','logging_active','msp_device_ip','loglevel') Values";
            $strsql.="(1,";
            $strsql.="'" . sqlite_escape_string ($logserver) . "',";
            $strsql.="'" . sqlite_escape_string ($logging_active) . "',";
            $strsql.="'192.168.173.1',";
            $strsql.="'" . sqlite_escape_string ($loglevel) . "')";



            if ($DEBUG)
                echo "isgwconf->DB: " . $strsql . " \n";
            $res = $db->delete("delete from general");
            $res = $db->insert_($strsql);
            if (!$res)
                error("isgwconf->DB(general)", __LINE__);
        }
    }
    return 1;
}

function isgwdialplan_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;
    if (!file_exists($strpath . "isgw.dialplan")) {
        if ($value == 0)
            error("isgw.dialplan not found", __LINE__);
        else
            return false;
    }
    $handle = @fopen($strpath . "isgw.dialplan", "r"); // Open file form read.
    $res = $db->delete("delete from dialplan");
    if ($handle) {
        $i = 0;
        $posid = 0;
        while (!feof($handle)) { // Loop til end of file.
            $buffer = fgets($handle, 4096); // Read a line.
            $ss = 0;
            if ($i >= 1) {
                $result = split("\t", $buffer);
                $z = 0;
                if (count($result) > "1") {
                    $isdnid = "";
                    if (substr($result[4], 0, 10) == "ISDNZUISDN") {
                        $isdnid = substr($result[4], 0, 23);
                        $result[4] = substr($result[4], 23);
                        $ss = 1;
                    }
                    if (substr($result[5], 0, 10) == "ISDNZUISDN") {
                        $isdnid = substr($result[5], 0, 23);
                        $result[5] = substr($result[5], 23);
                        $ss = 0;
                    }

                    if (strpos($result[0], ";#") === FALSE) $active=1;
                    else {
                        $result[0]=str_replace(";#", "", $result[0]);
                        $active=0;
                    }

                    //echo "configstring " . $result[8] . "\n";
                    //echo "configstring " . $result[0] . "\n";
                    //echo "configstring " . $result[1] . "\n";
                        if ($ss == 0) {
                            $posid = $posid + 1;
                            $strsql = "Insert into dialplan ('id','fromDirection','toDirection','fromId','toId','dest','newDest','src','newSrc','config','isdnid','posid','activ') ";
                            $strsql.="values (" . $i . ",";
                            $strsql.="'" . sqlite_escape_string ($result[0]) . "',";
                            $strsql.="'" . sqlite_escape_string ($result[1]) . "',";
                            $strsql.="'" . sqlite_escape_string ($result[2]) . "',";
                            $strsql.="'" . sqlite_escape_string ($result[3]) . "',";
                            $strsql.="'" . sqlite_escape_string ($result[4]) . "',";
                            $strsql.="'" . sqlite_escape_string ($result[5]) . "',";
                            $strsql.="'" . sqlite_escape_string ($result[6]) . "',";
                            $strsql.="'" . sqlite_escape_string ($result[7]) . "',";
                            $strsql.="'" . sqlite_escape_string ($result[8]) . "',";
                            $strsql.="'" . sqlite_escape_string ($isdnid) . "',";
                            $strsql.="'" . sqlite_escape_string ($posid) . "',";
                            $strsql.="'" . sqlite_escape_string ($active) . "')";

                            $strsql = str_replace("\\", "\\\\", $strsql);
                            $strsql = str_replace('""', '\"\"', $strsql);
                        } else {
                            $strsql = "update dialplan set 'toID'= '" . sqlite_escape_string ($result[3]) . "', toDirection='" . sqlite_escape_string ($result[1]) . "' where isdnid='" . sqlite_escape_string ($isdnid) . "'";
                        }
                    if ($DEBUG)
                        echo "isgwdialplan: " . $strsql . "\n";
                    $res = $db->insert_($strsql);
                    if (!$res)
                        error("isgwdialplan->DB", __LINE__);
                }
            }
            $i++;
        }//end while
    }
    return 1;
}

function isgwcpt_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;
    if (!file_exists($strpath . "isgw.cpt")) {
        if ($value == 0)
            error("no isgw.cpt", __LINE__);
        else
            return 1;
    }
    $handle = @fopen($strpath . "isgw.cpt", "r"); // Open file form read.
    $res = $db->delete("delete from callprogress");
    $res = $db->delete("delete from callprogress_entries");
    if ($handle) {
        $i = 0;
        $j = 1;
        while (!feof($handle)) { // Loop til end of file.
            $buffer = fgets($handle, 4096); // Read a line.
            $ss = 0;
            $result = split("\t", $buffer);
            $z = 0;


            if (substr($result[0], 0, 1) == "[") {
                $i++;
                $section = substr($result[0], 1, strlen($result[0]) - 3);
                $res = preg_split("/:/", $section);

                if ($res[0] == "s2i")
                    $cptDir = 'SIP-ISDN';
                elseif ($res[0] == "i2s")
                    $cptDir = 'ISDN-SIP';
                elseif ($res[0] == "s2fxo") {
                    $cptDir = 'SIP-FXO';
                }
                $strsql = "Insert into callprogress ('id','direction','name') ";
                $strsql.="values (" . sqlite_escape_string ($i) . ",";
                $strsql.="'" . sqlite_escape_string ($cptDir) . "',";
                $strsql.="'" . sqlite_escape_string ($res[1]) . "')";
                if ($DEBUG)
                    echo "isgwcpt: " . $strsql . "\n";
                $res = $db->insert_($strsql);
                if (!$res)
                    error("isgw.cpt: tables name insert failed", __LINE__);
            }elseif (substr($result[0], 0, 5) == "TIMER") {
                $res = preg_split("/=/", $result[0]);
                $strsql = "UPDATE callprogress set " . sqlite_escape_string (strtolower($res[0])) . "='" . sqlite_escape_string ($res[1]) . "' WHERE id='" . $i . "'";
                $res = $db->insert_($strsql);
            } elseif (count($result) > 2) {
                if ($cptDir == 'SIP-ISDN') {
                    $strsql = "Insert into callprogress_entries ('id','type','chann_det','isdn_event','sip_resp','resp_text','id_name') ";
                    $strsql.="values (" . $j++ . ",";
                    $strsql.="'" . sqlite_escape_string ($result[0]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[1]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[2]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[3]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[4]) . "',";
                    $strsql.="'" . $i . "')";
                    if ($DEBUG)
                        echo "isgwcpt:" . $strsql . "\n";
                }else if ($cptDir == 'ISDN-SIP') {
                    $strsql = "Insert into callprogress_entries ('id','type','isdn_event','resp_text','sip_resp', 'chann_det','id_name') ";
                    $strsql.="values (" . $j++ . ",";
                    $strsql.="'" . sqlite_escape_string ($result[0]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[1]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[2]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[3]) . "',";
                    $strsql.="'',";
                    $strsql.="'" . $i . "')";
                    if ($DEBUG)
                        echo "isgwcpt:" . $strsql . "\n";
                }else if ($cptDir == 'SIP-FXO') {
                    $strsql = "Insert into callprogress_entries ('id','type','isdn_event','sip_resp','resp_text', 'chann_det','id_name')";
                    $strsql.="values (" . $j++ . ",";
                    $strsql.="'',";
                    $strsql.="'" . sqlite_escape_string ($result[0]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[1]) . "',";
                    $strsql.="'" . sqlite_escape_string ($result[2]) . "',";
                    $strsql.="'',";
                    $strsql.="'" . $i . "')";
                    if ($DEBUG)
                        echo "isgwcpt:" . $strsql . "\n";
                }
                $res = $db->insert_($strsql);
                if (!$res)
                    error("isgwcpt: table entries insert failed", __LINE__);
            }
        }//end while
    }
    return 1;
}

function isgwsip_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;
    if (!file_exists($strpath . "isgw.sip")) {
        if ($value == 0)
            error("no isgw.sip found", __LINE__);
        else
            return false;
    }
    $result = make_parseable_inifile($strpath . "isgw.sip", $strpath . "isgw.sip.tmp");

    $result = parse_ini_file($strpath . "isgw.sip.tmp", true);
    $res = $db->delete("delete from sip_general");
    $res = $db->delete("delete from sip");
    $i = 0;
    foreach ($result as $section => $values) {
        if ($section == "general") {
            $sip_address = split(":", $result[$section][sip_address]);
            $bindport = $sip_address[2];
            $udpports = $result[$section][udpports];
            //$externip = $result[$section][externip];
            $tos_sip = $result[$section][tos_sip];
            $tos_rtp = $result[$section][tos_rtp];
            $rtp_port_selection = $result[$section][rtp_port_selection];
            $sip_over_tcp = $result[$section][sip_over_tcp];

            if ($sip_over_tcp == "")
                $sip_over_tcp = "0";
            if ($tos_sip == "")
                $tos_sip = "160";
            if ($tos_rtp == "")
                $tos_rtp = "160";
            $db->set("tos_rtp", sqlite_escape_string ($tos_rtp));
            $db->set("tos_sip", sqlite_escape_string ($tos_sip));
            $db->set("rtp_port_selection", sqlite_escape_string ($rtp_port_selection));
            $strsql = "update key_val set value='" . sqlite_escape_string ($sip_over_tcp) . "' where key='sip_over_tcp'";
            if ($DEBUG)
                echo "isgwsip->DB: " . $section . "Key_val:" . $strsql . " \n";
            $res = $db->insert_($strsql);
            if (!$res)
                error("isgwsip->DB(sip_over_tcp)", __LINE__);

            $strsql = "Insert into sip_general ('id','udpports','bindport') values (";
            $strsql.="1,";
            $strsql.="'" . sqlite_escape_string ($udpports) . "',";
            $strsql.="'" . sqlite_escape_string ($bindport) . "')";
            if ($DEBUG)
                echo "isgwsip->DB: " . $section . ":" . $strsql . " \n";
            $res = $db->insert_($strsql);
            if ((strpos($res, "failed") !== false) || !$res)
                error("isgwsip->DB(udpports,bindport)", __LINE__);

            //if ($res!=str_replace("failed","",$res))error("", __LINE__);
            //if (preg_match("/failed/",$res) || !$res)error("", __LINE__);
        }else {
            $i++;
            $address = $result[$section][address];

            $register = $result[$section][register];

            if ($register == "") {
                $register = $result[$section][type];
                if ($register == "") {
                    $register = 0;
                } else {
                    if ($register == "both") {
                        $register = 1;
                    } else {
                        $register = 0;
                    }
                }
            }

            $user = $result[$section][user];
            $auth_user = $result[$section][auth_user];
            $displayname = $result[$section][displayname];
            $sip_transport = $result[$section][transport];
            $secret = $result[$section][secret];
            $regrefresh = $result[$section][regrefresh];
            if ($regrefresh == "")
                $regrefresh = "300";
            $profile=$result[$section][profile];
            if ($profile == "")
                $profile = "manual";
            $matchtype=$result[$section][matchtype];
            $matchtype_manual=$result[$section][matchtype_manual];
            $stunserver = $result[$section][stunserver];
            $externip = $result[$section][externip];
            $config = $result[$section][config];
            $register_option = $result[$section][register_option];
            $default = $result[$section]['default'];
            if ($default != 1 && $default != 0)
                $default = 0;
            $enum_support = $result[$section][enum_support];
            if ($enum_support != 1 && $enum_support != 0)
                $enum_support = 0;
            $enum_search_domain = $result[$section][enum_search_domains];

            $strsql = "Insert into sip ('id','name','server_address',";
            $strsql.="'user','auth_user','displayname','sip_transport','secret','register','config','def','stunserver',";
            $strsql.="'externip','register_option','regrefresh','matchtype','matchtype_manual','profile','enum_support','enum_search_domain')";
            $strsql.=" values (";
            $strsql.=$i . ",";
            $strsql.="'" . sqlite_escape_string ($section) . "',";
            $strsql.="'" . sqlite_escape_string ($address) . "',";
            $strsql.="'" . sqlite_escape_string ($user) . "',";
            $strsql.="'" . sqlite_escape_string ($auth_user) . "',";
            $strsql.="'" . sqlite_escape_string ($displayname) . "',";
            $strsql.="'" . sqlite_escape_string ($sip_transport) . "',";
            $strsql.="'" . sqlite_escape_string ($secret) . "',";
            $strsql.="'" . sqlite_escape_string ($register) . "',";
            $strsql.="'" . sqlite_escape_string ($config) . "',";
            $strsql.="'" . sqlite_escape_string ($default) . "',";
            $strsql.="'" . sqlite_escape_string ($stunserver) . "',";
            $strsql.="'" . sqlite_escape_string ($externip) . "',";
            $strsql.="'" . sqlite_escape_string ($register_option) . "',";
            $strsql.="'" . sqlite_escape_string ($regrefresh) . "',";
            $strsql.="'" . sqlite_escape_string ($matchtype) . "',";
            $strsql.="'" . sqlite_escape_string ($matchtype_manual) . "',";
            $strsql.="'" . sqlite_escape_string ($profile) . "',";
            $strsql.="'" . sqlite_escape_string ($enum_support) . "',";
            $strsql.="'" . sqlite_escape_string ($enum_search_domain) . "')";
            if ($DEBUG)
                echo "isgwsip->DB: " . $section . ":" . $strsql . " \n";
            $res = $db->insert_($strsql);
            if ((strpos($res, "failed") !== false) || !$res)
                error("isgwsip->DB(name,server_address,user,secret,type,config,def,stunserver,externip,register_option,regrefresh)", __LINE__);
        }
    }
    $res = unlink($strpath . "isgw.sip.tmp");
    return 1;
}

function isgwisdn_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;

    if (!file_exists($strpath . "isgw.isdn"))
        error("no isgw.isdn found", __LINE__);

    $result = make_parseable_inifile($strpath . "isgw.isdn", $strpath . "isgw.isdn.tmp");
    $result = parse_ini_file($strpath . "isgw.isdn.tmp", true);

    foreach ($result as $section => $values) {
        if ($section != "general") {
            $ports = $result[$section][ports];
            $chansel = $result[$section][chansel];
            $chansel_dir = $result[$section][chansel_direction];
            $config = $result[$section][config];
            $tones = $result[$section][tones];
            $portpullup = $result[$section][portpullup];
            $odt = $result[$section][interdigit_timeout];
            $pcmlaw = $result[$section][pcmlaw];
            $country_code = $result[$section][country_code];
            $city_code = $result[$section][city_code];
            $local_area_code = $result[$section][local_area_code];

            if ($odt == "")
                $odt = $result[$section][interdigit_timeout];
            if ($odt == "")
                $odt = 3;
            
            if ($pcmlaw == "")
                $pcmlaw = "default";

            $odial = $result[$section][overlap_dialing];
            $qsig = $result[$section][qsig];
            if ($qsig == "")
                $qsig = "0";
            if ($qsig == 1) {
                $qsig = "1";
            } else {
                $qsig = "0";
            }
            if ($odial == "")
                $odial = "0";
            if ($odial == 1) {
                $odial = "1";
            } else {
                $odial = "0";
            }

            $odtwe = $result[$section][interdigit_timeout_initial];
            if ($odtwe == "")
                $odtwe = $result[$section][interdigit_timeout_initial];
            if ($odtwe == "")
                $odtwe = 15;

            $port = split(",", $ports);

            foreach ($port as $a) {

                $strsql = "Update isdn set ";
                $strsql.="chansel ='" . sqlite_escape_string ($chansel) . "'";
                $strsql.=",chansel_dir ='" . sqlite_escape_string ($chansel_dir) . "'";
                $strsql.=",gr='" . sqlite_escape_string ($section) . "'";
                $strsql.=",config='" . sqlite_escape_string ($config) . "'";
                $strsql.=",tones='[" . sqlite_escape_string ($tones) . "]'";
                $strsql.=",odt='" . sqlite_escape_string ($odt)."'";
                $strsql.=",odt_empty_dad='" . sqlite_escape_string ($odtwe)."'";
                $strsql.=",portpullup='" . sqlite_escape_string ($portpullup) . "'";
                $strsql.=",qsig='" . sqlite_escape_string ($qsig) . "'";
                $strsql.=",overlap_dialing='" . sqlite_escape_string ($odial) . "'";
                $strsql.=",pcmlaw='" . sqlite_escape_string ($pcmlaw) . "'";
                $strsql.=",country_code='" . sqlite_escape_string ($country_code) . "'";
                $strsql.=",city_code='" . sqlite_escape_string ($city_code) . "'";
                $strsql.=",local_area_code='" . sqlite_escape_string ($local_area_code) . "'";
                $strsql.=" where port='" . sqlite_escape_string ($a)."'";
                if ($DEBUG)
                    echo "ISGWISDN->DB: " . $section . ":" . $strsql . " \n";
                $res = $db->update($strsql);
                if (!$res)
                    error("ISGWISDN->DB(chansel,gr,config,tones,odt,odt_empty_dad,portpullup,qsig,overlap_dialing)", __LINE__);
            }
        }else {
            $time_from_isdn = $result[$section][time_from_isdn];
            if ($time_from_isdn == "")
                $time_from_isdn = "0";
            $dbroot = new beroAri($strpath . "root.db");
            $strsql = "Update root set value='" . sqlite_escape_string ($time_from_isdn) . "' where key='time_from_isdn'";
            if ($DEBUG)
                echo "ROOTDB:TIME_FROM_ISDN->DB: " . $strsql . "\n";
            $res = $dbroot->update($strsql);

            if (!$res) {
                if ($value == 0)
                    error("TIME_FROM_ISDN", __LINE__);
                else
                    return false;
            }else {
                if ($time_from_isdn != "0") {
                    $strsql = "Update root set value='' where key='ntphost'";
                    if ($DEBUG)
                        echo "ROOTDB:TIME_FROM_ISDN->DB: " . $strsql . "\n";
                    $res = $dbroot->update($strsql);
                    if (!$res)
                        error("TIME_FROM_ISDN(ntphost)", __LINE__);
                }
            }
        }
    }
    $res = unlink($strpath . "isgw.isdn.tmp");
    return 1;
}

function isgwanalog_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;

    if (!file_exists($strpath . "isgw.analog"))
        error("no isgw.analog found", __LINE__);

    $result = make_parseable_inifile($strpath . "isgw.analog", $strpath . "isgw.analog.tmp");
    $result = parse_ini_file($strpath . "isgw.analog.tmp", true);

    foreach ($result as $section => $values) {
        if ($section != "general") {
            $ports = $result[$section][ports];
            $config = $result[$section][config];
            $overlap_dial_timeout_empty_dad = $result[$section][interdigit_timeout_initial];
            $overlap_dial_timeout = $result[$section][interdigit_timeout];
            $overlap_dialing = $result[$section][overlap_dialing];
            $fxo_connect = $result[$section][fxo_connect];
            $fxo_wait_for_oad = $result[$section][fxo_wait_for_oad];
            $message_waiting_method = $result[$section][message_waiting_method];
            $tones = $result[$section][tones];
            $clip = $result[$section][clip];
            $cnip = $result[$section][cnip];
            $chansel = $result[$section][chansel];
            $chansel_dir = $result[$section][chansel_direction];
            $fxo_dialtone_passthrough = $result[$section][fxo_dialtone_passthrough];
            $fxo_call_ending_signal = $result[$section][fxo_call_ending_signal];
            $fxo_cid_detection_mode = $result[$section][fxo_cid_detection_mode];
            $port = split(",", $ports);

            foreach ($port as $a) {

                $strsql = "Update analog set ";
                $strsql.="gr='" . sqlite_escape_string ($section) . "'";
                $strsql.=",overlap_dial_timeout_empty_dad='" . sqlite_escape_string ($overlap_dial_timeout_empty_dad) . "'";
                $strsql.=",overlap_dial_timeout='" . sqlite_escape_string ($overlap_dial_timeout) . "'";
                $strsql.=",overlap_dialing='" . sqlite_escape_string ($overlap_dialing) . "'";
                $strsql.=",fxo_connect='" . sqlite_escape_string ($fxo_connect) . "'";
                $strsql.=",fxo_wait_for_oad='" . sqlite_escape_string ($fxo_wait_for_oad) . "'";
                $strsql.=",message_waiting_method='" . sqlite_escape_string ($message_waiting_method) . "'";
                $strsql.=",tones='[" . sqlite_escape_string ($tones) . "]'";
                $strsql.=",clip='" . sqlite_escape_string ($clip) . "'";
                $strsql.=",cnip='" . sqlite_escape_string ($cnip) . "'";
                $strsql.=",chansel='" . sqlite_escape_string ($chansel) . "'";
                $strsql.=",chansel_dir='" . sqlite_escape_string ($chansel_dir) . "'";
                $strsql.=",fxo_dialtone_passthrough='" . sqlite_escape_string ($fxo_dialtone_passthrough) . "'";
                $strsql.=",fxo_call_ending_signal='" . sqlite_escape_string ($fxo_call_ending_signal) . "'";
                $strsql.=",fxo_cid_detection_mode='" . sqlite_escape_string ($fxo_cid_detection_mode) . "'";
                $strsql.=",config='" . sqlite_escape_string ($config) . "'";
                $strsql.=" where port='" . sqlite_escape_string ($a)."'";
                if ($DEBUG)
                    echo "ISGWANALOG->DB: " . $section . ":" . $strsql . " \n";
                $res = $db->update($strsql);
                if (!$res)
                    error("ISGWANALOG->DB", __LINE__);
            }
        }
    }
    $res = unlink($strpath . "isgw.analog.tmp");
    return 1;
}
function isgwcas_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;

    if (!file_exists($strpath . "isgw.cas")) {
        if ($value == 0)
            error("no isgw.cas", __LINE__);
        else
            return 1;
    }

    $result = make_parseable_inifile($strpath . "isgw.cas", $strpath . "isgw.cas.tmp");
    $result = parse_ini_file($strpath . "isgw.cas.tmp", true);

    foreach ($result as $section => $values) {
        if ($section != "general") {
            $ports = $result[$section][ports];
            $e1sigtype = $result[$section][e1_signalling];
            $t1sigtype = $result[$section][t1_signalling];
            $config = $result[$section][config];
            $interdigit_timeout_initial = $result[$section][interdigit_timeout_initial];
            $interdigit_timeout = $result[$section][interdigit_timeout];
            $overlap_dialing = $result[$section][overlap_dialing];
            $fxo_callerid_detection_timeout = $result[$section][fxo_callerid_detection_timeout];
            $wait_for_oad = $result[$section][wait_for_oad];
            $fxo_wait_for_oad = $result[$section][fxo_wait_for_oad];
            $tones = $result[$section][tones];
            $clip = $result[$section][clip];
            $cnip = $result[$section][cnip];
            $chansel = $result[$section][chansel];
            $chansel_dir = $result[$section][chansel_direction];
            $dialtone_digits = $result[$section][dialtone_digits];
            $fxo_call_ending_signal = $result[$section][fxo_call_ending_signal];
            $fxo_cid_detection_mode = $result[$section][fxo_cid_detection_mode];
            $pcmlaw = $result[$section][pcmlaw];
            $port = split(",", $ports);

            foreach ($port as $a) {

                $strsql = "Update cas_channels set ";
                $strsql.="gr='" . sqlite_escape_string ($section) . "'";
                $strsql.=",e1sigtype='" . sqlite_escape_string ($e1sigtype) . "'";
                $strsql.=",t1sigtype='" . sqlite_escape_string ($t1sigtype) . "'";
                $strsql.=",interdigit_timeout_initial='" . sqlite_escape_string ($interdigit_timeout_initial) . "'";
                $strsql.=",interdigit_timeout='" . sqlite_escape_string ($interdigit_timeout) . "'";
                $strsql.=",overlap_dialing='" . sqlite_escape_string ($overlap_dialing) . "'";
                $strsql.=",fxo_callerid_detection_timeout='" . sqlite_escape_string ($fxo_callerid_detection_timeout) . "'";
                $strsql.=",fxo_wait_for_oad='" . sqlite_escape_string ($fxo_wait_for_oad) . "'";
                $strsql.=",wait_for_oad='" . sqlite_escape_string ($wait_for_oad) . "'";
                $strsql.=",tones='[" . sqlite_escape_string ($tones) . "]'";
                $strsql.=",clip='" . sqlite_escape_string ($clip) . "'";
                $strsql.=",cnip='" . sqlite_escape_string ($cnip) . "'";
                $strsql.=",chansel='" . sqlite_escape_string ($chansel) . "'";
                $strsql.=",chansel_dir='" . sqlite_escape_string ($chansel_dir) . "'";
                $strsql.=",dialtone_digits='" . sqlite_escape_string ($dialtone_digits) . "'";
                $strsql.=",fxo_call_ending_signal='" . sqlite_escape_string ($fxo_call_ending_signal) . "'";
                $strsql.=",fxo_cid_detection_mode='" . sqlite_escape_string ($fxo_cid_detection_mode) . "'";
                $strsql.=",pcmlaw='" . sqlite_escape_string ($pcmlaw) . "'";
                $strsql.=",config='" . sqlite_escape_string ($config) . "'";
                $strsql.=" where channel='" . sqlite_escape_string ($a)."'";
                if ($DEBUG)
                    echo "ISGWCAS->DB: " . $section . ":" . $strsql . " \n";
                $res = $db->update($strsql);
                if (!$res)
                    error("ISGWCAS->DB", __LINE__);
            }
        }
    }
    $res = unlink($strpath . "isgw.cas.tmp");
    return 1;
}

function isgwgsm_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;

    if (!file_exists($strpath . "isgw.gsm"))
        error("no isgw.gsm found", __LINE__);

    $result = make_parseable_inifile($strpath . "isgw.gsm", $strpath . "isgw.gsm.tmp");
    $result = parse_ini_file($strpath . "isgw.gsm.tmp", true);

    foreach ($result as $section => $values) {
        if ($section != "general") {
            $ports = $result[$section][ports];
            $config = $result[$section][config];
            $sms_extension = $result[$section][sms_extensions];
            $extension = $result[$section][extensions];
            $chansel = $result[$section][chansel];
            $chansel_dir = $result[$section][chansel_direction];

            $port = split(",", $ports);
            $i = 0;
            foreach ($port as $a) {

                $strsql = "Update gsm set ";
                $strsql.="gr='" . sqlite_escape_string ($section) . "'";
                $strsql.=",config='" . sqlite_escape_string ($config) . "'";
                $strsql.=",chansel='" . sqlite_escape_string ($chansel) . "'";
                $strsql.=",chansel_dir='" . sqlite_escape_string ($chansel_dir) . "'";
                $strsql.=",sms_extension='" . sqlite_escape_string ($sms_extension) . "'";
                $strsql.=",extension='" . sqlite_escape_string ($extension) . "'";
                $strsql.=" where port='" . sqlite_escape_string ($a)."'";
                $i++;
                if ($DEBUG)
                    echo "ISGWGSM->DB: " . $section . ":" . $strsql . " \n";
                $res = $db->update($strsql);
                if (!$res)
                    error("ISGWGSM->DB", __LINE__);
            }
        }
    }
    $res = unlink($strpath . "isgw.gsm.tmp");
    return 1;
}

function isgwcauses_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;

    if (!file_exists($strpath . "isgw.causes"))
        error("no isgw.causes", __LINE__);

    $causes = @file($strpath . "isgw.causes");
    if ($causes != NULL) {
        $strsql = "Delete from isgw_causes";
        if ($DEBUG)
            echo "ISGWCAUSES->DB: " . $strsql . " \n";
        $res = $db->update($strsql);
        foreach ($causes as $key => $line) {
            if (substr_count($line, ";", 0, 1) == 0 && $line != "" && $line != "\r" && $line != "\n" && $line != "\r\n") {
                $line = str_replace(array("\r\n", "\n", "\r"), "", $line);
                $values = explode("\t", $line);
                $strsql = "INSERT INTO isgw_causes (direction, to_cause, from_cause, sip_response_message)
					VALUES ('" . sqlite_escape_string ($values[0]) . "-" . sqlite_escape_string ($values[1]) . "','" . sqlite_escape_string ($values[2]) . "', '" . sqlite_escape_string ($values[3]) . "', '" . sqlite_escape_string ($values[4]) . "')";
                ;
                if ($DEBUG)
                    echo "ISGWCAUSES->DB: " . $strsql . " \n";
                $res = $db->update($strsql);
            }
        }
    }
    /*
      $strsql="Delete from key_val where key='causes_active'";
      if($DEBUG) echo "ISGWCAUSES->DB: " .$strsql ." \n";
      $res=$db->update($strsql);
      $strsql="Insert into key_val ('key','value') Values ('causes_active','" . $causes_active . "')";
      if($DEBUG) echo "ISGWCAUSES->DB: " .$strsql ." \n";
      $res=$db->update($strsql);
      if (!$res) error("", __LINE__);
     */
    return 1;
}

function networkacl_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;

    if (!file_exists($strpath . "network.acl")) {
        if ($value == 0)
            error("no network.acl", __LINE__);
        else
            return 1;
    }

    $acl = @file($strpath . "network.acl");
    if ($acl != NULL) {
        $strsql = "Delete from acl";
        if ($DEBUG)
            echo "NETWORKACL->DB: " . $strsql . " \n";
        $res = $db->update($strsql);

        $query_bindport = $db->select("select bindport from sip_general");
        $bindport = sqlite_fetch_single($query_bindport);

        foreach ($acl as $key => $line) {
            if ($line != "" && $line != "\r" && $line != "\n" && $line != "\r\n") {
                $line = str_replace(array("\r\n", "\n", "\r"), "", $line);
                $values = explode(";", $line);
                $address=explode("/",$values[3]);
                //SIP und SIP-TLS in der DB mit -1 und -2 speichert, die Ersetzung erfolgt bei create files
                if ($values[2]==$bindport) $values[2]=-1;
                elseif ($values[2]==$bindport+1) $values[2]=-2;
                $strsql = "INSERT INTO acl (protocol, dest_port, address, netmask)
					VALUES ('" . sqlite_escape_string ($values[1]) . "','" . sqlite_escape_string ($values[2]) . "','" . sqlite_escape_string ($address[0]) . "', '" . sqlite_escape_string ($address[1]) . "')";
                if ($DEBUG)
                    echo "NETWORKACL->DB: " . $strsql . " \n";
                file_put_contents("/tmp/acl.log", $strsql);
                $res = $db->update($strsql);
            }
        }
    }
    /*
      $strsql="Delete from key_val where key='causes_active'";
      if($DEBUG) echo "ISGWCAUSES->DB: " .$strsql ." \n";
      $res=$db->update($strsql);
      $strsql="Insert into key_val ('key','value') Values ('causes_active','" . $causes_active . "')";
      if($DEBUG) echo "ISGWCAUSES->DB: " .$strsql ." \n";
      $res=$db->update($strsql);
      if (!$res) error("", __LINE__);
     */
    return 1;
}

function misc_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;
    if (!file_exists($strpath . "misc.conf")) {
        if ($DEBUG)
            echo "NO MISC.CONF:\n";
        error("no misdn.conf", __LINE__);
    }

    $result = make_parseable_inifile($strpath . "misc.conf", $strpath . "misc.conf.tmp");
    $misc = parse_ini_file($strpath . "misc.conf.tmp", true);

    $dbroot = new beroAri($strpath . "root.db");
    $dbari = new beroAri($strpath . "ari.db");
    foreach ($misc as $section => $values) {
        //Time Settings
        check_and_update_root("ntphost", $misc[$section][ntphost], $dbroot, 0);
        check_and_update_root("timezone", $misc[$section][timezone], $dbroot, 0);
        check_and_update_root("summer_winter_time", $misc[$section][summer_winter_time], $dbari, 0);

        //berofos settings
        check_and_update_root("ip_berofos", $misc[$section]['bnfos-ipaddr'], $dbari, 0);
        check_and_update_root("mac_berofos", $misc[$section]['bnfos-mac'], $dbari, 0);
        check_and_update_root("interval_berofos", $misc[$section]['bnfos-intv'], $dbari, 0);
        check_and_update_root("use_boot_bnfoswdog", $misc[$section]['bnfos-hb-on-boot'], $dbroot, 1);

        //LAN Settings
        check_and_update_root("lan-iface", $misc[$section]['lan-iface'], $dbroot, 1);
        check_and_update_root("lan-ipaddr", $misc[$section]['lan-ipaddr'], $dbroot, 1);
        check_and_update_root("lan-netmask", $misc[$section]['lan-netmask'], $dbroot, 1);
        check_and_update_root("lan-gateway", $misc[$section]['lan-gateway'], $dbroot, 1);
        check_and_update_root("lan-nameserver", $misc[$section]['lan-nameserver'], $dbroot, 1);
        check_and_update_root("lan-dhcp", $misc[$section]['lan-dhcp'], $dbroot, 1);
        check_and_update_root("lan-mtu", $misc[$section]['lan-mtu'], $dbroot, 1);
        check_and_update_root("routing", $misc[$section]['routing'], $dbroot, 0);
        check_and_update_root("hostname", $misc[$section][hostname], $dbari, 0);

        //VLAN settings
        check_and_update_root("vlan-enable", $misc[$section]['vlan-enable'], $dbroot, 0);
        check_and_update_root("vlan-id", $misc[$section]['vlan-id'], $dbroot, 0);
        check_and_update_root("vlan-prio", $misc[$section]['vlan-prio'], $dbroot, 0);

        //MSP Settings
        check_and_update_root("msp-iface", $misc[$section]['msp-iface'], $dbroot, 1);
        check_and_update_root("msp-ipaddr", $misc[$section]['msp-ipaddr'], $dbroot, 1);

        //Provisioning
        check_and_update_root("use-boot-prov", $misc[$section]['use-boot-prov'], $dbroot, 1);
        check_and_update_root("tftp-host", $misc[$section]['tftp-host'], $dbroot, 0);
        check_and_update_root("tftp-url", $misc[$section]['tftp-url'], $dbroot, 0);
        check_and_update_root("provisioning-option", $misc[$section]['provisioning-option'], $dbroot, 1);
        check_and_update_root("userapp-enabled", $misc[$section]['userapp-enabled'], $dbroot, 0);
        check_and_update_root("beroAvahi-enabled", $misc[$section]['beroAvahi-enabled'], $dbroot, 0);

        //CIFS Share
        check_and_update_root("cifs_log_enabled", $misc[$section]['cifs_log_enabled'], $dbroot, 0);
        check_and_update_root("cifs_log_share", addslashes($misc[$section]['cifs_log_share']), $dbroot, 0);
        check_and_update_root("cifs_log_user", $misc[$section]['cifs_log_user'], $dbroot, 0);
        check_and_update_root("cifs_log_password", $misc[$section]['cifs_log_password'], $dbroot, 0);
        check_and_update_root("cifs_log_domain", $misc[$section]['cifs_log_domain'], $dbroot, 0);


        //Logging
        check_and_update_root("system-check-enabled", $misc[$section]['system-check-enabled'], $dbroot, 0);

        //Security
        check_and_update_root("safeguard", $misc[$section]['safeguard'], $dbroot, 0);
        check_and_update_root("excludelan", $misc[$section]['excludelan'], $dbroot, 0);

        //user
        $adminpass = $misc[$section]['admin-pass'];
        $adminuser = $misc[$section]['admin-user'];
        if (($adminpass != "") || ($adminuser == "admin")) {
            $strsql = "update users set password='" . sqlite_escape_string ($adminpass) . "' where user='" . sqlite_escape_string ($adminuser) . "'";
            if ($DEBUG)
                echo "MISC.CONF:" . $strsql . "\n";
            $dbari->update($strsql);
        }
        //misc
        check_and_update_root("show_app", $misc[$section]['sessions-disable'], $dbari, 0);
        check_and_update_root("set_hw", $misc[$section]['set_hw'], $dbari, 0);


        //API Password
        $apipass = $misc[$section]['api-pass'];
        if (strlen($apipass) != 0) {
            @unlink('/usr/conf/apiusers.conf');
            $handle = fopen('/usr/conf/apiusers.conf', 'w');
            fputs($handle, crypt($apipass, base64_encode($apipass)));
            if ($DEBUG)
                echo "MISC.CONF:api-pass=" . $apipass . "\n";
            fclose($handle);
        }

        //Cloud Settings
        check_and_update_root("cloudAddress", $misc[$section]['cloudAddress'], $dbari, 0);
        check_and_update_root("cloud_enable", $misc[$section]['cloud_enable'], $dbroot, 0);
        check_and_update_root("cloud_key", $misc[$section]['cloud_key'], $dbroot, 0);
        check_and_update_root("proxyEnabled", $misc[$section]['proxyEnabled'], $dbari, 0);
        check_and_update_root("proxyAddress", $misc[$section]['proxyAddress'], $dbari, 0);
        check_and_update_root("proxyPort", $misc[$section]['proxyPort'], $dbari, 0);
        check_and_update_root("proxyType", $misc[$section]['proxyType'], $dbari, 0);
        check_and_update_root("proxyUser", $misc[$section]['proxyUser'], $dbari, 0);
        check_and_update_root("proxySecret", $misc[$section]['proxySecret'], $dbari, 0);

        //HTTPS
        check_and_update_root("httpsOnly", $misc[$section]['httpsOnly'], $dbari, 0);

        //SNMP
        check_and_update_root("snmp-enabled", $misc[$section]['snmp-enabled'], $dbroot, 0);
        check_and_update_root("snmptraps", $misc[$section]['snmptraps'], $dbroot, 0);
        check_and_update_root("snmptraps_sink", $misc[$section]['snmptraps_sink'], $dbroot, 0);
        check_and_update_root("snmptraps_intervall", $misc[$section]['snmptraps_intervall'], $dbroot, 0);
        check_and_update_root("snmp-community-ro", $misc[$section]['snmp-community-ro'], $dbroot, 0);
        check_and_update_root("snmp-community-rw", $misc[$section]['snmp-community-rw'], $dbroot, 0);
        check_and_update_root("snmp-community-trap", $misc[$section]['snmp-community-trap'], $dbroot, 0);

        //check_and_update_root("app-image",$misc[$section]['app-image'],$dbroot,1);
        //check_and_update_root("app-status",$misc[$section]['app-status'],$dbroot,1);
        //check_and_update_root("root-version",$misc[$section]['root-version'],$dbroot,1);
    }
    $res = unlink($strpath . "misc.conf.tmp");
    return 1;
}

function check_and_update_root($key, $value, $db, $check) {
    global $DEBUG;


    //Sessions
    if ($key == "show_app") {
        $table = "set_app";
        $strsql = "Update " . $table . " set '" . $key . "'='" . sqlite_escape_string ($value) . "'";
        if ($DEBUG)
            echo "MISC.CONF:" . $strsql . "\n";
        $db->update($strsql);
        return;
    }
    //berofos & summer_wintertime
    if (($key == "ip_berofos") || ($key == "mac_berofos") || ($key == "interval_berofos") || ($key == "summer_winter_time")
            || ($key == "http_acl") || ($key == "sip_acl") || ($key == "rtp_acl") || ($key == "bfdetect_acl") || ($key == "ssh_acl")
            || ($key == "proxyEnabled") || ($key == "proxyAddress") || ($key == "proxyPort") || ($key == "proxyType")
            || ($key == "proxyUser") || ($key == "proxySecret") || ($key== "cloudAddress") || ($key == "hostname")
            || ($key == "httpsOnly") || ($key == "set_hw")) {

        $table = "key_val";

        $strsql = "Delete from " . $table . " where key='" . $key . "'";

        $db->update($strsql);
        $strsql = "Insert into " . $table . " ('key','value') Values ('" . $key . "','" . sqlite_escape_string ($value) . "')";
        //$strsql="Update " . $table . " set value='" . $value . "' where key='" . $key . "'";
        if ($DEBUG)
            echo "MISC.CONF:" . $strsql . "\n";
        $db->update($strsql);
        return;
    }
    //General root DB
    $table = "root";

    if ($check == 1) {

        if ($value != "") {

            if (value_exists($db, $key)) {
                $strsql = "Update " . $table . " set value='" . sqlite_escape_string ($value) . "' where key='" . $key . "'";
            } else {
                $strsql = "Insert into " . $table . " ('key','value') Values ('" . $key . "','" . sqlite_escape_string ($value) . "')";
            }
            //$db->update($strsql);
            //$strsql="Delete from " . $table . " where key='" . $key . "'";
            //$db->update($strsql);
            //$strsql="Insert into " . $table . " ('key','value') Values ('" . $key . "','" . $value . "')";
            //$strsql="Update " . $table . " set value='" . $value . "' where key='" . $key . "'";
            if ($DEBUG)
                echo "MISC.CONF:" . $strsql . "\n";
            $db->update($strsql);
        }
    }else {
        if (value_exists($db, $key)) {
            $strsql = "Update " . $table . " set value='" . sqlite_escape_string ($value) . "' where key='" . $key . "'";
        } else {
            $strsql = "Insert into " . $table . " ('key','value') Values ('" . $key . "','" . sqlite_escape_string ($value) . "')";
        }
        //$strsql="Delete from " . $table . " where key='" . $key . "'";
        //$db->update($strsql);
        //$strsql="Insert into " . $table . " ('key','value') Values ('" . $key . "','" . $value . "')";
        //$strsql="Update " . $table . " set value='" . $value . "' where key='" . $key . "'";
        if ($DEBUG)
            echo "MISC.CONF:" . $strsql . "\n";
        $db->update($strsql);
    }
    return;
}

function value_exists($db, $key) {

    $sql = "SELECT * FROM root WHERE key = '$key'";
    $res = $db->select($sql);
    if (!$res) {
        return false;
    }
    $row = sqlite_fetch_array($res);
    if (!$row) {
        return false;
    }
    return true;
}

function isdncfg_initoDB($db, $strpath, $value = 0) {
    global $DEBUG;
//echo "exist" . $strpath . "isdn.conf:" . file_exists($strpath . "isdn.conf") ."\n";
//$result=make_parseable_inifile($strpath . "isdn.conf",$strpath ."isdn.conf.tmp")

    $result = make_parseable_inifile($strpath . "hardware.conf", $strpath . "hardware.conf.tmp");

    $res = $db->delete("delete from isdn");
    $res = $db->delete("delete from analog");
    $res = $db->delete("delete from gsm");
    $res = $db->delete("delete from cas");
    $res = $db->delete("delete from cas_channels");
    $cfg = parse_ini_file($strpath . "hardware.conf.tmp", true);

    static $lifport_isdn = 0;
    static $lifport_analog = 0;
    static $lifport_gsm = 0;
    static $lifport_cas = 0;
    foreach ($cfg as $section => $values) {
        unset($master);
        unset($type);
        unset($country);
        unset($ohs);
        unset($ohs2);
        unset($rz);
        unset($rt);
        unset($rt2);
        unset($dcv);
        unset($mini);
        unset($ilim);
        unset($acim);
        unset($boostringer);
        unset($clock);
        unset($ntteSW);
        unset($termination);
        unset($ptp);
        unset($crystal_clock);
        unset($permanentl1);
        unset($portswitch);
        unset($pin);
        unset($smsc);
        unset($protocol);
        unset($interface_type);
        unset($country);
        unset($sigchan);

        switch ($section) {

            case "lif0":
                $lifnr = 0;
                $loop = 0;
                break;
            case "lif1":
                $lifnr = 1;
                $loop = 0;
                break;
            case "pcm":
                if ($DEBUG)
                    echo "Nothing Todo for section: " . $section . "\n";
                $loop = 1;
                break;
            default:
                if ($DEBUG)
                    echo "Unkown sectioname: " . $section . "\n";
                $loop = 1;
                break;
        }


        if ($loop)
            continue;

        $type = $cfg[$section][type];
        if (($type != "bf1t1e1" && $type != "bf2t1e1" && $type != "bf4t1e1" && $type != "bf4S0" && $type != "bf2S0" && $type != "bf1S0" && $type != "bf1E1" && $type != "bf2E1" && $type != "bf2S02FXS" && $type != "bf4FXS" && $type != "bf8FXS" && $type != "bf4FXO" && $type != "bf2FXO" && $type!="bf1FXS" && $type != "bf2GSM" && $type != "bf1GSM")) {
            if ($DEBUG)
                echo "Unkown module: " . $type . "\n";
            continue;
        }

        $ports = getports($type);

        $master = $cfg[$section][master];
        //echo "master " . $master . "\n";
        $clock = $cfg[$section][clock];

        $ntteSW = $cfg[$section][ntteSW];
        $ntteSW = split(",", $ntteSW);

        $crystal_clock = $cfg[$section][crystal_clock];
        $crystal_clock = split(",", $crystal_clock);

        $permanentl1 = $cfg[$section][permanentl1];
        $permanentl1 = split(",", $permanentl1);

        if ($type != "bf1t1e1" && $type != "bf2t1e1" && $type != "bf4t1e1" && $type != "bf4FXS" && $type != "bf8FXS" && $type != "bf4FXO" && $type != "bf2FXO"  && $type != "bf1FXS" && $type != "bf2GSM" && $type != "bf1GSM") {
            $ntteSW = getdefaultValue("NTTESW", $ntteSW, $ports);
            if ($clock == 5) {
                $db->set("sync_port_li" . $lifnr, '1');
            } else {
                $db->set("sync_port_li" . $lifnr, '0');
            }
            if ($clock === 0 || $clock=="") {
                $db->set("sync_port_auto" . $lifnr, '1');
            } else {
                $db->set("sync_port_auto" . $lifnr, '0');
            }
            //echo $clock . "\n";
            if ($master == 0)
                $clock = "0";
            $clock = getdefaultValue("CLOCK", ($clock=="") ? "0" : $clock, $ports);
        }
        $porttype = "";
        if ($type == "bf4S0" || $type == "bf2S02FXS" || $type == "bf2S0" || $type == "bf1S0") {
            $termination = $cfg[$section][termination];
            $ptp = $cfg[$section][ptp];
            if ($type == "bf4S0" && $ptp == "")
                $ptp = "1,1,1,1";
            $portswitch = $cfg[$section][portswitch];
            $ntteHW = $cfg[$section][ntteHW];

            $termination = split(",", $termination);
            $ptp = split(",", $ptp);
            $ntteHW = split(",", $ntteHW);
            $termination = getdefaultValue("TERMINATION", $termination, $ports);
            $ptp = getdefaultValue("PTP", $ptp, $ports);
            $portswitch = getdefaultValue("PORTSWITCH", $portswitch, $ports);
            $ntteHW = getdefaultValue("NTTEHW", $ntteHW, $ports);
            $porttype = "BRI";
            if ($type == "bf2S02FXS")
                $boostringer = $cfg[$section][boostringer];


            //echo "1portswitch=" .$portswitch ."\n";
            //echo "type=" .$type . "ports=" . $ports ."\n";
        }else if ($type == "bf1E1") {
            $termination = array("1");
            $ptp = array("1");
            $ntteHW = $ntteSW;
            $porttype = "PRI";
        } else if ($type == "bf2E1") {
            $termination = array("1", "1");
            $ptp = array("1", "1");
            $ntteHW = $ntteSW;
            $porttype = "PRI";
        } else if ($type == "bf2GSM" || $type == "bf1GSM") {
            $pin = $cfg[$section][pin];
            $smsc = $cfg[$section][smsc];

            $smsc = explode(",", $smsc);
            $pin = explode(",", $pin);
            $porttype = "GSM";
        } else if ($type == "bf4FXS" || $type=="bf1FXS" || $type=="bf8FXS") {
            $portswitch = $cfg[$section][portswitch];
            $portswitch = getdefaultValue("PORTSWITCH", $portswitch, $ports);
            $country = $cfg[$section][country];
            $boostringer = $cfg[$section][boostringer];
            $porttype = "FXS";
        } else if ($type == "bf4FXO" || $type == "bf2FXO") {
            $portswitch = $cfg[$section][portswitch];
            $portswitch = getdefaultValue("PORTSWITCH", $portswitch, $ports);
            $country = $cfg[$section][country];
            $ohs = $cfg[$section][ohs];
            $ohs2 = $cfg[$section][ohs2];
            $rz = $cfg[$section][rz];
            $rt = $cfg[$section][rt];
            $rt2 = $cfg[$section][rt2];
            $dcv = $cfg[$section][dcv];
            $ilim = $cfg[$section][ilim];
            $mini = $cfg[$section][mini];
            $acim = $cfg[$section][acim];
            $porttype = "FXO";
        } else if ($type == "bf1t1e1" || $type == "bf2t1e1" || $type == "bf4t1e1") {
            if ($clock == 254) {
                $db->set("sync_port_li" . $lifnr, '1');
            } else {
                $db->set("sync_port_li" . $lifnr, '0');
            }
            if ($clock == 0 || $clock=="") {
                $db->set("sync_port_auto" . $lifnr, '1');
            } else {
                $db->set("sync_port_auto" . $lifnr, '0');
            }
            //echo $clock . "\n";
            if ($master == 0)
                $clock = "0";
            $clock = getdefaultValue("CLOCK", $clock, $ports);
            $protocol = explode(",",$cfg[$section][protocol]);
            $termination = explode(",",$cfg[$section][termination]);
            $country = explode(",",$cfg[$section][country]);
            $sigchan = explode(",",$cfg[$section][sigchan]);
            $porttype = explode(",",$cfg[$section][interface_type]);
        }


        if ($type == "bf2GSM" || $type == "bf1GSM") {
            for ($i = 0; $i < $ports; $i++) {
                $port = $i + 1;
                $lifport_gsm++;
                $strsql = "INSERT INTO gsm ('type','lif','port','gr','pin','smsc','port_type')";
                $strsql.="VALUES('" . sqlite_escape_string ($type) . "','" . sqlite_escape_string ($lifnr) . "','" . sqlite_escape_string ($lifport_gsm) . "','NULL'";
                $strsql.= ",'" . sqlite_escape_string ($pin[$i]) . "','" . sqlite_escape_string ($smsc[$i]) . "','GSM')";

                if ($DEBUG)
                    echo "isdncfg->DB: " . $lifport . ":" . $strsql . "\n";
                $res = $db->insert_($strsql);

                if (!$res && !$DEBUG)
                    error("hardware.conf->DB(1GSM/2GSM, GSM)", __LINE__);
            }
        }elseif ($type == "bf1t1e1" || $type == "bf2t1e1" || $type == "bf4t1e1") {
            for ($i = 0; $i < $ports; $i++) {
                $port = $i + 1;
                $lifport_cas++;
                $strsql = "INSERT INTO cas ('type','lif','port','port_type','master','clock','protocol',";
                $strsql.= "'country','sigchan','termination')";
                $strsql.="VALUES('" . sqlite_escape_string ($type) . "','" . sqlite_escape_string ($lifnr) . "','" . sqlite_escape_string ($lifport_cas) . "'";
                $strsql.= ",'".sqlite_escape_string ($porttype[$i])."' ,'" . sqlite_escape_string ($master) . "' ,'" . sqlite_escape_string ($clock[$i]) . "'";
                $strsql.= ",'" . sqlite_escape_string ($protocol[$i]) . "' ,'" . sqlite_escape_string ($country[$i]) . "'";
                $strsql.= ",'" . sqlite_escape_string ($sigchan[$i]) . "','". sqlite_escape_string ($termination[$i]). "')";
                if (strtolower($porttype[$i])=="cas"){
                    if ($protocol[$i]=="t1") $channels=24;
                    elseif ($protocol[$i]=="e1") $channels=30;
                    for ($j = 1; $j <= $channels; $j++) {
                        $db->insert_("INSERT INTO cas_channels (port) VALUES('".$lifport_cas."');");
                    }
                //ISDN Eintrag bei hdlc speichern
                }elseif (strtolower($porttype[$i])=="hdlc"){
                    $db->insert_('INSERT INTO isdn (type, lif, master, port_type, ccs) ' .
                                'VALUES (\'' . $type . '\',\'' . $lifnr . '\',\'0\',\'PRI\',\'1\');');
                    $lifport_isdn++;
                }
                if ($DEBUG)
                    echo "isdncfg->DB: " . $lifport . ":" . $strsql . "\n";
                $res = $db->insert_($strsql);

                if (!$res && !$DEBUG)
                    error("hardware.conf->DB(1t1e1/2t1e1, T1E1)", __LINE__);
            }
        }elseif ($type == "bf2S02FXS") {
            for ($i = 0; $i < 2; $i++) {
                $port = $i + 1;
                $lifport_isdn++;
                $strsql = "INSERT INTO isdn ('type','lif','port','gr','ptp','ntteHW','ntteSW',";
                $strsql.="'config','lt','clock','chansel','tones','odt','odt_empty_dad','master','port_type','permanentl1')";
                $strsql.="VALUES('" . sqlite_escape_string ($type) . "','" . sqlite_escape_string ($lifnr) . "','" . sqlite_escape_string ($lifport_isdn) . "','NULL'";
                $strsql.= ",'" . sqlite_escape_string ($ptp[$i]) . "','" . sqlite_escape_string ($ntteSW[$i]) . "','" . sqlite_escape_string ($ntteHW[$i]) . "','','" . sqlite_escape_string ($termination[$i]) . "','" . sqlite_escape_string ($clock[$i])."'";
                $strsql.= ",'standard','[de]',3,15,'" . sqlite_escape_string ($master) . "','BRI', '" . sqlite_escape_string ($permanentl1[$i]) . "')";

                if ($DEBUG)
                    echo "isdncfg->DB: " . $lifport . ":" . $strsql . "\n";
                $res = $db->insert_($strsql);

                if (!$res && !$DEBUG)
                    error("hardware.conf->DB(2s02fxs, isdn part)", __LINE__);
            }
            for ($i = 0; $i < 2; $i++) {
                $port = $i + 1;
                $lifport_analog++;
                $strsql = "INSERT INTO analog ('type','lif','port','gr',";
                $strsql.="'config','master','port_type')";
                $strsql.="VALUES('" . sqlite_escape_string ($type) . "','" . sqlite_escape_string ($lifnr) . "','" . sqlite_escape_string ($lifport_analog) . "','NULL'";
                $strsql.= ", '', '" . sqlite_escape_string ($master) . "','FXS')";

                if ($DEBUG)
                    echo "isdncfg->DB: " . $lifport . ":" . $strsql . "\n";
                $res = $db->insert_($strsql);

                if (!$res && !$DEBUG)
                    error("hardware.conf->DB(2s02fxs,analog part)", __LINE__);
            }
        }elseif ($type == "bf4FXS" || $type == "bf1FXS" || $type == "bf8FXS" || $type == "bf4FXO" || $type == "bf2FXO") {
            for ($i = 0; $i < $ports; $i++) {
                $port = $i + 1;
                $lifport_analog++;
                $strsql = "INSERT INTO analog ('type','lif','port','gr',";
                $strsql.="'config','master','port_type')";
                $strsql.="VALUES('" . sqlite_escape_string ($type) . "','" . sqlite_escape_string ($lifnr) . "','" . sqlite_escape_string ($lifport_analog) . "','NULL'";
                $strsql.= ", '', " . sqlite_escape_string ($master) . ",'" . sqlite_escape_string ($porttype) . "')";

                if ($DEBUG)
                    echo "isdncfg->DB: " . $lifport . ":" . $strsql . "\n";
                $res = $db->insert_($strsql);

                if (!$res && !$DEBUG)
                    error("hardware.conf->DB(4fxs/4fxo/2fxo/1fxs)", __LINE__);
            }
        }else {
            for ($i = 0; $i < $ports; $i++) {
                $port = $i + 1;
                $lifport_isdn++;
                /*
                  $strsql="INSERT INTO isdn VALUES('" . $type . "'," . $lifnr ."," .  $lifport .",'NULL'";
                  $strsql.= "," . $ptp[$i] . ",'" . $ntteSW[$i] . "','" . $ntteHW[$i] . "',''," . $termination[$i] . "," . $clock[$i];
                  $strsql.= ",'standard','[de]',3,15," . $master .")";
                 */
                $strsql = "INSERT INTO isdn ('type','lif','port','gr','ptp','ntteHW','ntteSW',";
                $strsql.="'lt','clock','chansel','tones','odt','odt_empty_dad','master','port_type', 'crystal_clock', 'permanentl1')";
                $strsql.="VALUES('" . sqlite_escape_string ($type) . "'," . $lifnr . "," . $lifport_isdn . ",'NULL'";
                $strsql.= ",'" . sqlite_escape_string ($ptp[$i]) . "','" . sqlite_escape_string ($ntteSW[$i]) . "','" . sqlite_escape_string ($ntteHW[$i]) . "','" . sqlite_escape_string ($termination[$i]) . "','" . sqlite_escape_string ($clock[$i]) ."'";
                $strsql.= ",'standard','[de]',3,15,'" . sqlite_escape_string ($master) . "','" . sqlite_escape_string ($porttype) . "','" . sqlite_escape_string ($crystal_clock[$i]) . "', '" . sqlite_escape_string ($permanentl1[$i]) . "')";

                if ($DEBUG)
                    echo "isdncfg->DB: " . $lifport . ":" . $strsql . "\n";
                $res = $db->insert_($strsql);

                if (!$res && !$DEBUG)
                    error("hardware.conf->DB(isdn)", __LINE__);
            }
        }

        if ($type == "bf4S0" || $type == "bf4FXS" || $type == "bf4FXO"  || $type == "bf2S02FXS") {
            $strsql = "Delete from key_val where key='portswitch'";
            $res = $db->delete($strsql);
            $strsql = "Insert into key_val ('key','value') Values ('portswitch','" . sqlite_escape_string ($portswitch) . "')";
            if ($DEBUG)
                echo "isdncfg->DB: key_val Portswitch:" . $strsql . "\n";
            $res = $db->insert_($strsql);
            if (!$res && !$DEBUG)
                error("hardware.conf->DB(portswitch)", __LINE__);
        }
        if ($type == "bf4FXS" || $type == "bf8FXS" || $type == "bf4FXO" || $type == "bf2FXO" || $type == "bf2S02FXS" || $type == "bf1FXS") {
            analog_key_val("country", $country, $db);
            analog_key_val("ohs", $ohs, $db);
            analog_key_val("ohs2", $ohs2, $db);
            analog_key_val("rz", $rz, $db);
            analog_key_val("rt", $rt, $db);
            analog_key_val("rt2", $rt2, $db);
            analog_key_val("dcv", $dcv, $db);
            analog_key_val("ilim", $ilim, $db);
            analog_key_val("mini", $mini, $db);
            analog_key_val("acim", $acim, $db);
            
        }
        if ($type == "bf4FXS" || $type == "bf8FXS" || $type == "bf2S02FXS" || $type == "bf1FXS") {
            $strsql = "Delete from key_val where key='boostringer'";
            $res = $db->delete($strsql);
            $strsql = "Insert into key_val ('key','value') Values ('boostringer','" . sqlite_escape_string ($boostringer) . "')";
            if ($DEBUG)
                echo "isdncfg->DB: key_val boostringer:" . $strsql . "\n";
            $res = $db->insert_($strsql);
            if (!$res && !$DEBUG)
                error("hardware.conf->DB(4fxs, 2s02fxs, 1fxs boostringer)", __LINE__);
        }
    }//end first for loop

    $res = unlink($strpath . "hardware.conf.tmp");
    return 1;
}

function analog_key_val($key,$val,$db){
    $strsql = "Delete from key_val where key='".$key."'";
            $res = $db->delete($strsql);
            $strsql = "Insert into key_val ('key','value') Values ('".$key."','" . sqlite_escape_string ($val) . "')";
            if ($DEBUG)
                echo "isdncfg->DB: key_val ".$key.":" . $strsql . "\n";
            $res = $db->insert_($strsql);
            if (!$res && !$DEBUG)
                error("hardware.conf->DB(4fxs,4fxo, 2fxo, 2s02fxs, 1fxs ".$key.")", __LINE__);
}

function getports($stype) {
    $stype = trim(strtolower($stype));
    switch ($stype) {
        case bf4s0:
        case bf4fxs:
        case bf4fxo:
        case bf4t1e1:
            return 4;
            break;
        case bf1s0:
        case bf1e1:
        case bf1gsm:
        case bf1fxs:
        case bf1t1e1:
            return 1;
            break;
        case bf2e1:
        case bf2s0:
        case bf2fxo:
        case bf2gsm:
        case bf2s02fxs:
        case bf2t1e1:
            return 2;
            break;
        case bf8fxs:
            return 8;
            break;
        default:
            return -1;
            break;
    }
}

function getdefaultValue($sname, $val, $iports) {

    //unset($tmp);

    if ($sname == "PORTSWITCH") {
        if (!strlen($val))
            return 0;

        $arr = array('0', '1');
        if (!in_array($val, $arr, true))
            error("hardware.conf: portswitch out of range", __LINE__);
        return $val;
    }

    if ($sname == "CLOCK") {
        $arr = array('0', '1', '2', '3', '4', '5', '254');
        if (!in_array($val, $arr, true))
            error("hardware.conf: clock out of range", __LINE__);
        if ($val == 5 || $val==254) {
            for ($i = 1; $i <= $iports; $i++) {
                $tmp[$i - 1] = $val;
            }
        } else {

            for ($i = 1; $i <= $iports; $i++) {


                if ($val == $i) {

                    $tmp[$i - 1] = "1";
                } else {

                    $tmp[$i - 1] = "0";
                }
            }
        }
        return $tmp;
    }

    if ($sname == "PTP" || $sname == "TERMINATION") {
        if (count($val) != $iports || !is_numeric($val[0])) {

            /* for ($i = 1; $i <= $iports ; $i++){
              $tmp[$i-1]="1";

              } */
            error("hardware.conf: PTP/TERMINATION out of range", __LINE__);
            return $tmp;
        }
    }

    if ($sname == "NTTESW" || $sname == "NTTEHW") {
        if (count($val) != $iports || empty($val[0])) {

            /* for ($i = 1; $i <= $iports ; $i++){
              $tmp[$i-1]="te";
              } */
            error("hardware.conf: NTTESW/NTTEHW out of range", __LINE__);
            return $tmp;
        }
    }


    return $val;
}

?>
